package inescID.RMIwithSSL;

/**
 * <p>Title: e-voto</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

import java.io.*;
import java.net.*;
import java.rmi.server.*;
import javax.net.ssl.*;


public class RMISSLServerSocketFactory
        implements RMIServerSocketFactory, Serializable {

  public RMISSLServerSocketFactory () {
  }

  public ServerSocket createServerSocket(int port)
      throws IOException
  {
    ServerSocket s=null;
    try {
      SSLServerSocketFactory ssf = (SSLServerSocketFactory)
          SSLServerSocketFactory.getDefault();
      s = ssf.createServerSocket(port);
      s.setSoTimeout(5000); //ms
      } catch (Exception e) {
      e.printStackTrace();
    }
    return s;
  }
}


