package inescID.revs.commissioner;

import java.awt.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.util.Vector;
import java.util.GregorianCalendar;
import java.util.Calendar;
import javax.swing.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */
import inescID.revs.util.Configuration;

public class ConfigurationSelection extends JPanel {

  Vector configurations;
  Configuration configuration;


  Box box1;
  JPanel pTitle = new JPanel();
  JLabel title = new JLabel();
  JScrollPane listScrollPane = new JScrollPane();
  JLabel lDescriptiton = new JLabel();
  JList selectionList = new JList();
  Box box3;
  JButton next = new JButton();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  Component component2;
  Box box5;
  JComboBox number_of_administrators = new JComboBox();
  Component component3;
  JLabel lsignatures = new JLabel();
  JComboBox required_signatures = new JComboBox();
  JButton back = new JButton();
  JLabel lstart = new JLabel();
  JPanel pMain = new JPanel();
  Component component1;
  JPanel jPanel1 = new JPanel();
  JTextField description = new JTextField();
  Box mainBox;
  JLabel lAdministrators = new JLabel();
  JPanel pButtons1 = new JPanel();
  JComboBox start_month = new JComboBox();
  JComboBox start_day = new JComboBox();
  JComboBox start_year = new JComboBox();
  JLabel lend = new JLabel();
  JComboBox end_month = new JComboBox();
  JComboBox end_day = new JComboBox();
  JComboBox end_year = new JComboBox();
  JComboBox start_hour = new JComboBox();
  JComboBox end_hour = new JComboBox();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JLabel jLabel6 = new JLabel();
  JCheckBox anonymizers = new JCheckBox();
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;
  JPanel jPanel2 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JCheckBox election_keys = new JCheckBox();
  JCheckBox signing_keys = new JCheckBox();
  JPanel jPanel3 = new JPanel();
  VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();

  public ConfigurationSelection(Commissioner commi) {
      this.setActionListener(commi);
      try {
        jbInit();
      }
      catch(Exception ex) {
        ex.printStackTrace();
      }
      init();
    }


  public ConfigurationSelection() {
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    box1 = Box.createVerticalBox();
    box3 = Box.createVerticalBox();
    component2 = Box.createHorizontalStrut(43);
    box5 = Box.createVerticalBox();
    component3 = Box.createHorizontalStrut(8);
    component1 = Box.createVerticalStrut(13);
    mainBox = Box.createHorizontalBox();
    titledBorder1 = new TitledBorder("");
    titledBorder2 = new TitledBorder("");
    this.setEnabled(true);
    this.setMinimumSize(new Dimension(0, 0));

    this.setOpaque(true);
    this.setPreferredSize(new Dimension(0, 0));
    title.setFont(new java.awt.Font("Dialog", 0, 18));
    title.setMinimumSize(new Dimension(98, 15));
    title.setText("Configuration Selection");
    listScrollPane.setPreferredSize(new Dimension(200, 270));
    lDescriptiton.setText("Description");
    next.setEnabled(false);
    next.setMaximumSize(new Dimension(71, 23));
    next.setMinimumSize(new Dimension(71, 23));
    next.setOpaque(true);
    next.setPreferredSize(new Dimension(71, 23));
    next.setHorizontalAlignment(SwingConstants.CENTER);
    next.setHorizontalTextPosition(SwingConstants.CENTER);
    next.setText("Finish");
    next.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
    next.setVerticalTextPosition(javax.swing.SwingConstants.CENTER);
    lsignatures.setPreferredSize(new Dimension(98, 15));
    lsignatures.setText("Required Signatures");
    back.setMaximumSize(new Dimension(71, 23));
    back.setMinimumSize(new Dimension(71, 23));
    back.setPreferredSize(new Dimension(71, 23));
    back.setHorizontalTextPosition(SwingConstants.CENTER);
    back.setMargin(new Insets(2, 14, 2, 14));
    back.setText("Back");
    lstart.setToolTipText("");
    lstart.setText("Start (dd/mm/yyyy - hh)");
    jPanel1.setLayout(gridBagLayout1);
    description.setEditable(false);
    description.setText("");
    description.setColumns(40);
    lAdministrators.setOpaque(false);
    lAdministrators.setText("N. Admnistrators");
    pButtons1.setLayout(borderLayout1);
    number_of_administrators.setEnabled(false);
    number_of_administrators.setMinimumSize(new Dimension(50, 19));
    number_of_administrators.setPreferredSize(new Dimension(50, 19));
    required_signatures.setEnabled(false);
    required_signatures.setMinimumSize(new Dimension(50, 19));
    required_signatures.setPreferredSize(new Dimension(50, 19));
    lend.setMaximumSize(new Dimension(114, 15));
    lend.setMinimumSize(new Dimension(114, 15));
    lend.setOpaque(false);
    lend.setPreferredSize(new Dimension(114, 15));
    lend.setRequestFocusEnabled(true);
    lend.setText("End (dd/mm/yyyy - hh)");
    start_day.setEnabled(false);
    start_day.setMinimumSize(new Dimension(50, 19));
    start_day.setPreferredSize(new Dimension(50, 19));
    end_day.setEnabled(false);
    end_day.setMinimumSize(new Dimension(50, 19));
    end_day.setPreferredSize(new Dimension(50, 19));
    start_month.setEnabled(false);
    start_month.setMinimumSize(new Dimension(50, 19));
    start_month.setPreferredSize(new Dimension(50, 19));
    end_month.setEnabled(false);
    end_month.setMinimumSize(new Dimension(50, 19));
    end_month.setPreferredSize(new Dimension(50, 19));
    end_year.setEnabled(false);
    end_year.setMinimumSize(new Dimension(50, 19));
    end_year.setPreferredSize(new Dimension(50, 19));
    start_year.setEnabled(false);
    start_year.setMinimumSize(new Dimension(50, 19));
    start_year.setPreferredSize(new Dimension(50, 19));
    end_hour.setEnabled(false);

    end_hour.setMinimumSize(new Dimension(50, 19));
    end_hour.setPreferredSize(new Dimension(50, 19));
    start_hour.setEnabled(false);

    start_hour.setMinimumSize(new Dimension(50, 19));
    start_hour.setPreferredSize(new Dimension(50, 19));
    jLabel1.setFont(new java.awt.Font("Dialog", 1, 14));
    jLabel1.setRequestFocusEnabled(true);
    jLabel1.setText("  /  ");
    jLabel2.setFont(new java.awt.Font("Dialog", 1, 14));
    jLabel2.setText("  /  ");
    jLabel3.setFont(new java.awt.Font("Dialog", 1, 14));
    jLabel3.setText("  /  ");
    jLabel4.setFont(new java.awt.Font("Dialog", 1, 14));
    jLabel4.setOpaque(false);
    jLabel4.setText("  /  ");
    jLabel5.setFont(new java.awt.Font("Dialog", 1, 14));
    jLabel5.setText("  -  ");
    jLabel6.setFont(new java.awt.Font("Dialog", 1, 14));
    jLabel6.setText("  -  ");
    anonymizers.setEnabled(false);
    anonymizers.setHorizontalTextPosition(SwingConstants.RIGHT);
    anonymizers.setText("Use Anonymizers");
    election_keys.setText("Create new election keys");
    signing_keys.setText("Create Administrators signing keys");
    jPanel3.setLayout(verticalFlowLayout1);
    selectionList.addListSelectionListener(new ConfigurationSelection_selectionList_listSelectionAdapter(this));
    pButtons1.add(jPanel2,  BorderLayout.SOUTH);
    jPanel2.add(back, null);
    jPanel2.add(next, null);
    pButtons1.add(jPanel3,  BorderLayout.CENTER);
    box3.add(jPanel1, null);
    jPanel1.add(lAdministrators,                           new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 10, 5, 10), 0, 0));
    jPanel1.add(lstart,                                 new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 10, 5, 10), 0, 0));
    jPanel1.add(lDescriptiton,                          new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 0, 0, 0), 0, 0));
    jPanel1.add(description,                              new GridBagConstraints(1, 0, 7, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(10, 0, 5, 0), 0, 0));
    jPanel1.add(number_of_administrators,                          new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(start_month,                           new GridBagConstraints(3, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(start_day,                          new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(end_month,               new GridBagConstraints(3, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(end_day,               new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 0, 5, 0), 0, 0));
    jPanel1.add(lend,                     new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 10, 5, 10), 0, 0));
    jPanel1.add(end_year,              new GridBagConstraints(5, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(start_hour,              new GridBagConstraints(7, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(end_hour,              new GridBagConstraints(7, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    this.add(box1, null);
    box1.add(pTitle, null);
    pTitle.add(title, null);
    box1.add(pMain, null);
    pMain.add(box3, null);
    box3.add(component1, null);
    box3.add(mainBox, null);
    mainBox.add(listScrollPane, null);
    mainBox.add(component2, null);
    mainBox.add(box5, null);
    mainBox.add(component3, null);
    box5.add(pButtons1, null);
    listScrollPane.getViewport().add(selectionList, null);
    jPanel1.add(jLabel1,           new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel2,           new GridBagConstraints(4, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel3,         new GridBagConstraints(2, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel4,        new GridBagConstraints(4, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel5,        new GridBagConstraints(6, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel6,      new GridBagConstraints(6, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(lsignatures,   new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 10, 5, 0), 0, 0));
    jPanel1.add(required_signatures,   new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(start_year,  new GridBagConstraints(5, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(anonymizers,    new GridBagConstraints(3, 3, 5, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 10, 0, 0), 0, 0));
    jPanel3.add(election_keys, null);
    jPanel3.add(signing_keys, null);
  }


  void init(){
    int i;
    //hour
    for (i = 0; i < 24; i++) {
      this.start_hour.addItem(new String(Integer.toString(i) + "h"));
      this.end_hour.addItem(new String(Integer.toString(i) + "h"));
    }


    //days
    for (i = 1; i <= 31; i++) {
      this.start_day.addItem(new Integer(i));
      this.end_day.addItem(new Integer(i));
    }

  //months
    for (i = 1; i <= 12; i++) {
      this.start_month.addItem(new Integer(i));
      this.end_month.addItem(new Integer(i));
    }

    //years
    Calendar calendar = GregorianCalendar.getInstance();
    i = calendar.get(Calendar.YEAR);
    int j = i + 10;
    i -= 10;
    for (; i < j; i++) {
      this.start_year.addItem(new Integer(i));
      this.end_year.addItem(new Integer(i));
    }


    for(i=1; i < 11; i++){
      this.number_of_administrators.addItem(new Integer(i));
      this.required_signatures.addItem(new Integer(i));
    }

  }

  public void releaseMemory(){
      this.configurations = null;
      this.configuration=null;
      this.selectionList.removeAll();
  }


  public void updateList(Vector configurations){
   this.configurations = configurations;
   Vector aux = new Vector(this.configurations.size());
   for(int i=0; i < this.configurations.size(); i++){
     aux.add(((Configuration) this.configurations.get(i)).GetDescription());
   }
   this.selectionList.setListData(aux);
   this.clear();

}

 void clear(){
     this.description.setText("");
     this.start_day.setSelectedIndex(-1);
     this.start_month.setSelectedIndex(-1);
     this.start_year.setSelectedIndex(-1);
     this.start_hour.setSelectedIndex(-1);
     this.end_day.setSelectedIndex(-1);
     this.end_month.setSelectedIndex(-1);
     this.end_year.setSelectedIndex(-1);
     this.end_hour.setSelectedIndex(-1);
     this.anonymizers.setSelected(true);
     this.number_of_administrators.setSelectedIndex(-1);
     this.required_signatures.setSelectedIndex(-1);
   }

  public Configuration getConfiguration(){
    Configuration configuration;
    configuration = (Configuration) this.configurations.get(this.selectionList.getSelectedIndex());
    return configuration;
  }

  public boolean generateElectionKeys(){
    return this.election_keys.isSelected();
  }

  public boolean generateAdministratorsSigningKeys(){
    return this.signing_keys.isSelected();
  }


  public void showKeys(boolean option){
    this.election_keys.setVisible(option);
    this.signing_keys.setVisible(option);
  }


  public void setActionListener(Commissioner commi) {
     back.addActionListener(new ConfigurationSelection_back_actionAdapter(commi));
     next.addActionListener(new ConfigurationSelection_next_actionAdapter(commi));
     }



  void selectionList_valueChanged(ListSelectionEvent e) {
    if (this.selectionList.getSelectedIndex() >= 0) {
      this.configuration =
          (Configuration)this.configurations.get(this.selectionList.getSelectedIndex());

      this.description.setText(this.configuration.GetDescription());
      this.anonymizers.setSelected(this.configuration.UseAnonymizers());
      this.number_of_administrators.setSelectedIndex(
          this.configuration.GetReqAdministrators() - 1);
      this.required_signatures.setSelectedIndex(
          this.configuration.GetReqSignatures() - 1);

      GregorianCalendar calendar = new GregorianCalendar();
      calendar.setTimeInMillis(this.configuration.GetStart());
      this.start_day.setSelectedIndex(calendar.get(Calendar.DAY_OF_MONTH) - 1);
      this.start_month.setSelectedIndex(calendar.get(Calendar.MONTH));
      this.start_year.setSelectedItem(new Integer(calendar.get(Calendar.YEAR)));
      this.start_hour.setSelectedIndex(calendar.get(Calendar.HOUR_OF_DAY));

      calendar.setTimeInMillis(this.configuration.GetEnd());
      this.end_day.setSelectedIndex(calendar.get(Calendar.DAY_OF_MONTH) - 1);
      this.end_month.setSelectedIndex(calendar.get(Calendar.MONTH));
      this.end_year.setSelectedItem(new Integer(calendar.get(Calendar.YEAR)));
      this.end_hour.setSelectedIndex(calendar.get(Calendar.HOUR_OF_DAY));

      this.next.setEnabled(true);
    }


  }





}

class ConfigurationSelection_selectionList_listSelectionAdapter implements javax.swing.event.ListSelectionListener {
  ConfigurationSelection adaptee;

  ConfigurationSelection_selectionList_listSelectionAdapter(ConfigurationSelection adaptee) {
    this.adaptee = adaptee;
  }
  public void valueChanged(ListSelectionEvent e) {
    adaptee.selectionList_valueChanged(e);
  }
}

class ConfigurationSelection_back_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  ConfigurationSelection_back_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.SCback_actionPerformed(e);
  }
}

class ConfigurationSelection_next_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  ConfigurationSelection_next_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.SCnext_actionPerformed(e);
  }
}


