package inescID.revs.commissioner;

import java.awt.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */
import inescID.revs.util.IdDescription;

public class GroupAdministration extends JPanel {

  public static final byte NONE = 0;
  public static final byte UPDATE = 1;
  public static final byte NEW = 2;

  private byte state;

  private Vector groups;
  int group_index=-1;

  Box box1;
  JPanel pTitle = new JPanel();
  JLabel title = new JLabel();
  JPanel pMain = new JPanel();
  Box mainBox;
  JScrollPane listScrollPane = new JScrollPane();
  JList selectionList = new JList();

  Box box5;
  JLabel Lgroup = new JLabel();
  JButton rename = new JButton();
  JButton New = new JButton();
  JButton ok = new JButton();
  JPanel pButtons = new JPanel();
  JButton back = new JButton();
  JButton delete = new JButton();
  BoxLayout2 pButtonsLayout = new BoxLayout2();
  JPanel jPanel1 = new JPanel();
  JButton manage = new JButton();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  Component space2;
  Component space3;
  JTextField group_name = new JTextField();
  JButton cancel = new JButton();
  Component apace1;


  public GroupAdministration(Commissioner commi) {
    this.start();
    this.setActionListener(commi);
  }



  public GroupAdministration() {
    this.start();

  }

  private void start(){

    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    box1 = Box.createVerticalBox();
    mainBox = Box.createHorizontalBox();
    box5 = Box.createVerticalBox();
    space2 = Box.createVerticalStrut(41);
    space3 = Box.createVerticalStrut(12);
    apace1 = Box.createVerticalStrut(25);
    this.setBorder(BorderFactory.createEtchedBorder());
    this.setMinimumSize(new Dimension(0, 0));

    this.setOpaque(true);
    this.setPreferredSize(new Dimension(0, 0));
    title.setFont(new java.awt.Font("Dialog", 0, 18));
    title.setMinimumSize(new Dimension(98, 15));
    title.setText("Group Administration");


    listScrollPane.setPreferredSize(new Dimension(200, 400));
    selectionList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    selectionList.addListSelectionListener(new GroupAdministration_selectionList_listSelectionAdapter(this));

    Lgroup.setText("Group");
    rename.setEnabled(false);
    rename.setMaximumSize(new Dimension(71, 23));
    rename.setOpaque(true);
    rename.setHorizontalAlignment(SwingConstants.CENTER);
    rename.setHorizontalTextPosition(SwingConstants.CENTER);
    rename.setText("Rename");
    rename.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
    rename.setVerticalTextPosition(javax.swing.SwingConstants.CENTER);
    rename.addActionListener(new GroupAdministration_rename_actionAdapter(this));
    New.setEnabled(false);
    New.setMaximumSize(new Dimension(71, 23));
    New.setHorizontalTextPosition(SwingConstants.CENTER);
    New.setMnemonic('0');
    New.setSelected(false);
    New.setText("New");
    New.addActionListener(new GroupAdministration_New_actionAdapter(this));

    ok.setEnabled(false);
    ok.setMaximumSize(new Dimension(65, 23));
    ok.setMinimumSize(new Dimension(65, 23));
    ok.setPreferredSize(new Dimension(65, 23));
    ok.setMnemonic('0');
    ok.setText("OK");

    pButtons.setLayout(pButtonsLayout);
    back.setMaximumSize(new Dimension(71, 23));
    back.setHorizontalTextPosition(SwingConstants.CENTER);
    back.setMargin(new Insets(2, 14, 2, 14));
    back.setText("Back");

    delete.setEnabled(false);
    delete.setMaximumSize(new Dimension(71, 23));
    delete.setHorizontalTextPosition(SwingConstants.CENTER);
    delete.setText("Delete");

    pButtonsLayout.setAxis(BoxLayout.Y_AXIS);
    jPanel1.setLayout(gridBagLayout1);
    manage.setEnabled(false);
    manage.setHorizontalAlignment(SwingConstants.CENTER);
    manage.setHorizontalTextPosition(SwingConstants.CENTER);
    manage.setMnemonic('0');
    manage.setText("Manage");

    group_name.setEditable(false);
    group_name.setSelectionStart(11);
    group_name.setText("");
    cancel.setEnabled(false);
    cancel.setText("Cancel");
    cancel.addActionListener(new GroupAdministration_cancel_actionAdapter(this));
    this.add(box1, null);
    box1.add(pTitle, null);
    pTitle.add(title, null);
    box1.add(pMain, null);
    pMain.add(mainBox, null);
    mainBox.add(listScrollPane, null);
    mainBox.add(box5, null);
    listScrollPane.getViewport().add(selectionList, null);
    jPanel1.add(group_name,    new GridBagConstraints(1, 0, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 0, 0, 0), 180, 0));
    jPanel1.add(Lgroup,    new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 10, 0, 10), 0, 0));
    jPanel1.add(ok,    new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(10, 50, 0, 10), 0, 0));
    jPanel1.add(cancel,    new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 0, 0, 0), 0, 0));
    pButtons.add(space3, null);
    pButtons.add(jPanel1, null);
    pButtons.add(rename, null);
    pButtons.add(manage, null);
    pButtons.add(New, null);
    pButtons.add(delete, null);
    pButtons.add(space2, null);
    box5.add(pButtons, null);
    pButtons.add(back, null);
    pButtons.add(apace1, null);
  }


  public void releaseMemory(){
    this.groups = null;
    this.selectionList.removeAll();
}


  public void updateList(Vector list){


    this.groups = list;
    Vector aux = new Vector(this.groups.size());

    for (int i=0; i<this.groups.size(); i++)
      aux.add(((IdDescription) this.groups.get(i)).GetDescription());

    this.selectionList.setListData(aux);

    if(this.state == GroupAdministration.NONE)
      this.group_index = -1;
    else{
      if(this.state == GroupAdministration.NEW)
        this.group_index = groups.size()-1;

      this.selectionList.setSelectedIndex(group_index);
      this.selectionList.ensureIndexIsVisible(group_index);
    }


    this.state = GroupAdministration.NONE;


    this.reset();
 }


 public IdDescription getGroup()
  {
    IdDescription group;
    if (this.state == GroupAdministration.NEW){
      group = new IdDescription();
      IdDescription aux = (IdDescription)this.groups.lastElement();
      group.SetId(aux.GetId() + 1);
    }
    else {
      group = (IdDescription)this.groups.get(this.group_index);
    }
    group.SetDescription(this.group_name.getText());
    return group;
  }

public byte getState(){
  return this.state;
}

  public void setActionListener(Commissioner commi) {
      back.addActionListener(new GroupAdministration_back_actionAdapter(commi));
      delete.addActionListener(new GroupAdministration_delete_actionAdapter(commi));
      ok.addActionListener(new GroupAdministration_ok_actionAdapter(commi));
      manage.addActionListener(new GroupAdministration_manage_actionAdapter(commi));
  }


  void enableActions(){
    this.manage.setEnabled(true);

    this.delete.setEnabled(true);
    this.rename.setEnabled(true);
  }

  void disableActions(){
    this.manage.setEnabled(false);

    this.delete.setEnabled(false);
    this.rename.setEnabled(false);
  }





  void selectionList_valueChanged(ListSelectionEvent e) {
    this.changeGroup();
  }

  private void changeGroup(){
    if(this.selectionList.getSelectedIndex()>=0){
      this.group_index = this.selectionList.getSelectedIndex();
      this.group_name.setText(((IdDescription)(this.groups.get(this.group_index))).GetDescription());
      this.enableActions();
    }
    else{
      this.disableActions();
      this.group_name.setText("");
    }

  }

  void cancel_actionPerformed(ActionEvent e) {
    this.reset();
  }

  void reset()
  {
    this.group_name.setEditable(false);
    this.ok.setEnabled(false);
    this.cancel.setEnabled(false);

    this.back.setEnabled(true);
    this.New.setEnabled(true);
    this.selectionList.setEnabled(true);
    this.changeGroup();
  }

  void rename_actionPerformed(ActionEvent e) {
    this.disableActions();
    this.back.setEnabled(false);
    this.selectionList.setEnabled(false);
     this.New.setEnabled(false);

    this.state = GroupAdministration.UPDATE;

    this.group_name.setEditable(true);
    this.ok.setEnabled(true);
    this.cancel.setEnabled(true);
  }

  void New_actionPerformed(ActionEvent e) {
     this.disableActions();
     this.back.setEnabled(false);
     this.selectionList.setEnabled(false);
     this.New.setEnabled(false);

     this.state = GroupAdministration.NEW;

     this.group_name.setText("");
     this.group_name.setEditable(true);
     this.ok.setEnabled(true);
     this.cancel.setEnabled(true);
   }

}

class GroupAdministration_cancel_actionAdapter implements java.awt.event.ActionListener {
  GroupAdministration adaptee;

  GroupAdministration_cancel_actionAdapter(GroupAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cancel_actionPerformed(e);
  }
}

class GroupAdministration_rename_actionAdapter implements java.awt.event.ActionListener {
  GroupAdministration adaptee;

  GroupAdministration_rename_actionAdapter(GroupAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.rename_actionPerformed(e);
  }
}

class GroupAdministration_ok_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  GroupAdministration_ok_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.GMok_actionPerformed(e);
  }
}

class GroupAdministration_manage_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  GroupAdministration_manage_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.GMmanage_actionPerformed(e);
  }
}

class GroupAdministration_New_actionAdapter implements java.awt.event.ActionListener {
  GroupAdministration adaptee;

  GroupAdministration_New_actionAdapter(GroupAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.New_actionPerformed(e);
  }
}

class GroupAdministration_delete_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  GroupAdministration_delete_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.GMdelete_actionPerformed(e);
  }
}

class GroupAdministration_back_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  GroupAdministration_back_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.GMback_actionPerformed(e);
  }
}

class GroupAdministration_selectionList_listSelectionAdapter implements javax.swing.event.ListSelectionListener {
  GroupAdministration adaptee;

  GroupAdministration_selectionList_listSelectionAdapter(GroupAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void valueChanged(ListSelectionEvent e) {
    adaptee.selectionList_valueChanged(e);
  }
}



