package inescID.revs.commissioner;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import java.util.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */
import inescID.revs.util.*;

public class SelectVoters extends JPanel {

  int group_id=0;
  Voters2Group group_voters;
  Vector remaining_voters;


  Box box1;
  JScrollPane jScrollPaneVoters = new JScrollPane();
  JScrollPane jScrollPaneGroup = new JScrollPane();
  JPanel jPanel2 = new JPanel();

  JList voters_list = new JList();
  JList group_list = new JList();
  JButton remove_all = new JButton();
  JButton ok = new JButton();
  JButton add = new JButton();
  JButton add_all = new JButton();
  JButton remove = new JButton();
  JButton cancel = new JButton();
  VerticalFlowLayout verticalFlowLayout2 = new VerticalFlowLayout();
  JPanel jPanel3 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JPanel jPanel4 = new JPanel();
  JPanel jPanel5 = new JPanel();
  JPanel jPanel6 = new JPanel();
  JLabel title = new JLabel();
  JLabel group_name = new JLabel();

  public SelectVoters() {
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public SelectVoters(Commissioner commi) {
    this.setActionListener(commi);
    try {
        jbInit();
      }
      catch(Exception ex) {
        ex.printStackTrace();
      }

  }

  void jbInit() throws Exception {
    box1 = Box.createHorizontalBox();
    remove_all.setText("<< Remove all");
    remove_all.addActionListener(new SelectVoters_remove_all_actionAdapter(this));
    ok.setText("OK");

    jScrollPaneVoters.setMaximumSize(new Dimension(32767, 32767));
    jScrollPaneVoters.setMinimumSize(new Dimension(23, 23));
    jScrollPaneVoters.setPreferredSize(new Dimension(150, 400));
    jScrollPaneGroup.setMaximumSize(new Dimension(32767, 32767));
    jScrollPaneGroup.setPreferredSize(new Dimension(150, 400));
    jPanel2.setLayout(verticalFlowLayout2);
    add.setText("Add  >");
    add.addActionListener(new SelectVoters_add_actionAdapter(this));
    add_all.setToolTipText("");
    add_all.setText("Add all >>");
    add_all.addActionListener(new SelectVoters_add_all_actionAdapter(this));
    remove.setToolTipText("");
    remove.setText("< Remove");
    remove.addActionListener(new SelectVoters_remove_actionAdapter(this));
    cancel.setText("Cancel");

    jPanel3.setMinimumSize(new Dimension(10, 50));
    jPanel3.setPreferredSize(new Dimension(71, 150));
    voters_list.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
    group_list.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
    this.setLayout(borderLayout1);
    jPanel1.setFont(new java.awt.Font("Dialog", 0, 18));
    jPanel1.setMinimumSize(new Dimension(80, 40));
    jPanel1.setPreferredSize(new Dimension(80, 40));
    title.setFont(new java.awt.Font("Dialog", 0, 18));
    title.setText("Select Voters: ");
    group_name.setFont(new java.awt.Font("Dialog", 0, 18));
    group_name.setText("group");
    this.add(box1, BorderLayout.CENTER);
    box1.add(jScrollPaneVoters, null);
    jScrollPaneVoters.getViewport().add(voters_list, null);
    box1.add(jPanel2, null);
    jPanel2.add(add, null);
    jPanel2.add(remove, null);
    jPanel2.add(add_all, null);
    jPanel2.add(remove_all, null);
    jPanel2.add(jPanel3, null);
    jPanel2.add(ok, null);
    jPanel2.add(cancel, null);
    box1.add(jScrollPaneGroup, null);
    this.add(jPanel4, BorderLayout.SOUTH);
    this.add(jPanel1,  BorderLayout.NORTH);
    jPanel1.add(title, null);
    this.add(jPanel5, BorderLayout.EAST);
    this.add(jPanel6, BorderLayout.WEST);
    jScrollPaneGroup.getViewport().add(group_list, null);
    jPanel1.add(group_name, null);
  }

  void add_actionPerformed(ActionEvent e) {
    Object[] add = this.voters_list.getSelectedValues();
    this.add_voters(add);
  }

  void remove_actionPerformed(ActionEvent e) {
    Object[] remove = this.group_list.getSelectedValues();
    this.remove_voters(remove);
  }

  void add_all_actionPerformed(ActionEvent e) {
    this.add_voters(this.remaining_voters.toArray());

  }

  void remove_all_actionPerformed(ActionEvent e) {
    this.remove_voters(this.group_voters.GetVoters().toArray());
  }

  void add_voters (Object[] voters){
    for(int i=0; i < voters.length; i++){
      this.group_voters.GetVoters().add(voters[i]);
      this.remaining_voters.remove(voters[i]);
    }

    this.group_list.setListData(this.group_voters.GetVoters());
    this.voters_list.setListData(this.remaining_voters);
  }

  void remove_voters (Object[] voters){
    for(int i=0; i < voters.length; i++){
      this.remaining_voters.add(voters[i]);
      this.group_voters.GetVoters().remove(voters[i]);
    }

    this.group_list.setListData(this.group_voters.GetVoters());
    this.voters_list.setListData(this.remaining_voters);
  }

  public Voters2Group getGroupVoters(){
    return this.group_voters;
  }


  public void setActionListener(Commissioner commi) {
      ok.addActionListener(new SelectVoters_ok_actionAdapter(commi));
      cancel.addActionListener(new SelectVoters_cancel_actionAdapter(commi));
      }


public void init(String group_name, Voters2Group group_voters, Vector all_voters){
  this.group_name.setText(group_name);
  this.remaining_voters = all_voters;
  this.group_voters = group_voters;

  this.group_list.setListData(this.group_voters.GetVoters());
  this.voters_list.setListData(this.remaining_voters);
}

public void releaseMemory(){
  this.group_list.removeAll();
  this.voters_list.removeAll();
  this.group_voters = null;
  this.remaining_voters = null;
}


}

class SelectVoters_add_actionAdapter implements java.awt.event.ActionListener {
  SelectVoters adaptee;

  SelectVoters_add_actionAdapter(SelectVoters adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.add_actionPerformed(e);
  }
}

class SelectVoters_remove_actionAdapter implements java.awt.event.ActionListener {
  SelectVoters adaptee;

  SelectVoters_remove_actionAdapter(SelectVoters adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.remove_actionPerformed(e);
  }
}

class SelectVoters_add_all_actionAdapter implements java.awt.event.ActionListener {
  SelectVoters adaptee;

  SelectVoters_add_all_actionAdapter(SelectVoters adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.add_all_actionPerformed(e);
  }
}

class SelectVoters_remove_all_actionAdapter implements java.awt.event.ActionListener {
  SelectVoters adaptee;

  SelectVoters_remove_all_actionAdapter(SelectVoters adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.remove_all_actionPerformed(e);
  }
}

class SelectVoters_ok_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  SelectVoters_ok_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.SVok_actionPerformed(e);
  }
}

class SelectVoters_cancel_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  SelectVoters_cancel_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.SVcancel_actionPerformed(e);
  }
}
