package inescID.revs.database;



/**
 * <p>Title: REVS</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public class Clock
    extends Thread {

  final long wait = 600000; //10 minutes
  CommonDatabase db;

  public Clock(CommonDatabase db) {
    this.db = db;
  }

  public void run() {
    while(true) {
      try {
        Thread.sleep(this.wait);
        this.db.verify();
      } catch (Exception e) {
        e.printStackTrace();
      }
    }
  }

}
