package inescID.revs.displayBallot;

import javax.swing.*;
import java.util.Vector;
import java.awt.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

import inescID.revs.xml.*;

public class PanelMultipleOptions
    extends PanelOptions {
  JCheckBox[] option_buttons;

  public PanelMultipleOptions() {
    FlowLayout flowLayout = new FlowLayout();
    flowLayout.setAlignment(flowLayout.LEFT);
    this.setLayout(flowLayout);
   }

  public void setOptions(Vector options){


     QuestionOption option;
     this.options = options;
     this.option_buttons = new JCheckBox[this.options.size()];

     for(int i=0; i<this.options.size(); i++){
       option = (QuestionOption) this.options.get(i);
       this.option_buttons[i] = new JCheckBox(option.getOption());
       this.add(this.option_buttons[i]);
     }
   }

  /**
   * clear
   */
  void clear() {
    for(int i=0; i < this.option_buttons.length; i++){
      this.option_buttons[i].setSelected(false);
    }
  }
  /**
   * getAnswer
   */
  QuestionAnswer getAnswer() {
    QuestionAnswer answer = new QuestionAnswer();

    QuestionOption option;
    for(int i=0; i<this.option_buttons.length; i++){
      if (this.option_buttons[i].isSelected()){
        option = (QuestionOption) this.options.get(i);
        answer.addAnswer(option.getCode());
      }
    }
    return answer;
  }

}
