package inescID.revs.displayBallot;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

import inescID.revs.xml.*;



public class PanelQuestion extends JPanel {
  BorderLayout borderLayout1 = new BorderLayout();
  JTextArea question_description = new JTextArea();
//  JTextField question_description = new JTextField();
  PanelOptions options;
  BallotQuestion question;
  TitledBorder titledBorder3;
  JPanel question_control = new JPanel();
  JButton clear = new JButton();
  BorderLayout borderLayout2 = new BorderLayout();


  public PanelQuestion() {
    question_description.setLineWrap(true);
    question_description.setWrapStyleWord(true);
    question_description.setFont(new java.awt.Font("DialogInput", 1, 14));
    question_description.setText("");
    question_description.setEditable(false);
    question_description.setBackground(SystemColor.control);
    question_description.setBorder(BorderFactory.createEtchedBorder());
//    question_description.sclo



    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {

    titledBorder3 = new TitledBorder("");
//    question_description.setBackground(SystemColor.info);
  this.setBorder(titledBorder3);
    this.setLayout(borderLayout1);
    clear.setMaximumSize(new Dimension(75, 18));
    clear.setMinimumSize(new Dimension(75, 18));
    clear.setPreferredSize(new Dimension(75, 18));
    clear.setHorizontalAlignment(SwingConstants.CENTER);
    clear.setHorizontalTextPosition(SwingConstants.CENTER);
    clear.setMnemonic('0');
    clear.setText("Clear");
    clear.addActionListener(new PanelQuestion_clear_actionAdapter(this));
    question_control.setLayout(borderLayout2);


    this.add(this.question_description, BorderLayout.NORTH);

    this.add(question_control, BorderLayout.SOUTH);
    question_control.add(clear,  BorderLayout.EAST);

  }


  public void setQuestion(BallotQuestion question){
    this.question = question;
    this.question_description.setText(" " + this.question.getDescription());

    switch(this.question.getType()){
      case BallotQuestion.SINGLE_TYPE:
        this.options = new PanelSingleOptions();
        break;
      case BallotQuestion.OPEN_SINGLE_TYPE:
        this.options = new PanelOpenSingleOptions();
        break;
      case BallotQuestion.MULTIPLE_TYPE:
        this.options = new PanelMultipleOptions();
        break;
      case BallotQuestion.OPEN_MULTIPLE_TYPE:
        this.options = new PanelOpenMultipleOptions();
        break;
    }
    this.options.setOptions(this.question.getOptions());
    this.add(this.options,  BorderLayout.CENTER);
  }


 BallotQuestion getAnswers(){
   this.question.setAnswer(this.options.getAnswer());
   return this.question;

 }

 void clear_actionPerformed(ActionEvent e){
   this.options.clear();
 }


 void setPortuguese(){
   this.clear.setText("Limpar");
   this.options.setPortuguese();
 }

}

class PanelQuestion_clear_actionAdapter implements java.awt.event.ActionListener {
  PanelQuestion adaptee;

  PanelQuestion_clear_actionAdapter(PanelQuestion adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.clear_actionPerformed(e);
  }
}
