package inescID.revs.servers;

/**
 * <p>Title: REVS</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */


import inescID.crypto.PasswordGenerator;
import java.security.*;

public class AnonymizerSubmission
    extends Thread {

  int wait;
  AnonymizerEngine anonymizer;
  PasswordGenerator random;
  boolean stop = false;

  public AnonymizerSubmission(AnonymizerEngine anonymizer, int wait) {
    this.anonymizer = anonymizer;
    this.wait = wait;
    try {
      random = new PasswordGenerator();
    }
    catch (NoSuchAlgorithmException ex) {
    }
  }

  public void run() {
    while(true) {
      if (stop) return;
      try {
        long sleep = random.GetRandomNumber(0, this.wait);
   //     System.out.println("sleep: " + sleep);
        Thread.sleep(sleep);
        this.anonymizer.forwardVotes();
       // this.anonymizer.wait();
      } catch (Exception e) {
        e.printStackTrace();
      }
    }
  }

  public void stop_safe(){
    this.stop = true;
  }

}
