package inescID.revs.util;

import java.security.Key;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public class AdministratorElectionAddress extends AdministratorElection
    implements java.io.Serializable {

  String URL;
  String description;


  public AdministratorElectionAddress() {
  }

  public AdministratorElectionAddress(int adm, String adm_description,
                                      String url, int election, byte[] key) {
    super(adm, election, key);
    this.description = adm_description;
    this.URL = url;
  }

  public AdministratorElectionAddress(Server adm, int election, byte[] key) {
    super(adm.GetId(), election, key);
    this.description = adm.GetDescription();
    this.URL = adm.GetURL();
  }

  public AdministratorElectionAddress(Server adm, AdministratorElection adm_election) {
    super(adm.GetId(), adm_election.GetElection(), adm_election.GetKey());
    this.description = adm.GetDescription();
    this.URL = adm.GetURL();
  }


  public String getAdministratorURL(){
    return this.URL;
  }

  public String getAdministratorDescription(){
    return this.description;
  }

}
