package inescID.revs.util;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */



public class Configuration extends ConfigurationDates implements java.io.Serializable {

  int required_administrators;
  int required_signatures;
  boolean enable_anonymizers;

  public Configuration() {
  }

  public Configuration(int Id_Configuration, String Description, long Start, long End,
                       int Req_Administrators, int Req_Signatures, boolean Enable_Anonymizers){
    super(Id_Configuration, Description, Start, End);
    this.SetReqAdministrators(Req_Administrators);
    this.SetReqSignatures(Req_Signatures);
    this.SetUseAnonymizers(Enable_Anonymizers);
  }

  public Configuration(ConfigurationDates conf){
   super(conf.GetId(), conf.GetDescription(), conf.GetStart(), conf.GetEnd());
   this.SetReqAdministrators(0);
   this.SetReqSignatures(0);
   this.SetUseAnonymizers(false);
 }


  public void SetReqAdministrators(int Req_Administrators){
     required_administrators = Req_Administrators;
   }
   public int GetReqAdministrators(){
     return required_administrators;
  }

  public void SetReqSignatures(int Req_Signatures){
     required_signatures = Req_Signatures;
   }
   public int GetReqSignatures(){
     return required_signatures;
  }

  public void SetUseAnonymizers(boolean Enable){
     enable_anonymizers = Enable;
   }
   public boolean UseAnonymizers(){
     return enable_anonymizers;
  }

}
