package inescID.revs.util;

import java.util.Vector;

/**
 * <p>Title: e-voto</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */
import inescID.crypto.MixCipherEnvelope;


public class TransferAdministrator implements java.io.Serializable {

  Vector elections; //Election
  Vector voters_groups; //Voters2Group
  ConfigurationDates configuration; //ConfigurationDates
  MixCipherEnvelope passwords; //Vector of IdPassword
  MixCipherEnvelope signing_keys; //Vector of AdministratorElection


  public TransferAdministrator(Vector elections, Vector groups,
                               ConfigurationDates configuration,
                               MixCipherEnvelope passwords,
                               MixCipherEnvelope keys) {
    this.voters_groups = groups;
    this.elections = elections;
    this.configuration = configuration;
    this.passwords = passwords;
    this.signing_keys = keys;
  }

  public MixCipherEnvelope getPasswords (){
    return this.passwords;
  }

  public Vector getVotersGroups () {
    return this.voters_groups;
  }

  public Vector getElections () {
    return this.elections;
  }

  public MixCipherEnvelope getSigningKeys () {
    return this.signing_keys;
  }

  public ConfigurationDates getConfiguration () {
      return this.configuration;
    }

}
