package inescID.revs.util;

import java.util.Vector;

/**
 * <p>Title: e-voto</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

import java.util.Vector;

public class TransferDistributor implements java.io.Serializable {

  Vector signed_ballots; //SignedObject Ballot
  Vector voters_groups; //Voters2Group
  Vector elections; //Election
  Vector voters; //IdDescription
  ConfigurationDates configuration; //ConfigurationDates


  public TransferDistributor(Vector ballots, Vector groups, Vector elections,
                             Vector voters, ConfigurationDates configuration) {
    this.signed_ballots = ballots;
    this.voters_groups = groups;
    this.elections = elections;
    this.voters = voters;
    this.configuration = configuration;
  }

  public Vector getBallots (){
    return this.signed_ballots;
  }

  public Vector getVotersGroups () {
    return this.voters_groups;
  }

  public Vector getElections () {
    return this.elections;
  }

  public Vector getVoters () {
    return this.voters;
  }

  public ConfigurationDates getConfiguration () {
      return this.configuration;
    }


}
