package inescID.revs.util;


/**
 * <p>Title: REVS</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public class Vote
    implements java.io.Serializable{

  int id_election;
  String xml_answers=null;
  byte[] random_value=null;
  AdministratorSignature[] signatures=null;

  public Vote() {
  }

  public Vote(int election, String xml_answers, byte[] random_value,
             AdministratorSignature[] signatures) {
   this.id_election = election;
   this.xml_answers = xml_answers;
   this.random_value = random_value;
   this.signatures = signatures;
  }


  public void setIdElection(int election) {
    this.id_election = election;
  }

  public void setAnswers(String xml_answers) {
    this.xml_answers = xml_answers;
  }

  public void setSignatures(AdministratorSignature[] signatures) {
    this.signatures = signatures;
  }

  public void setRandomValue(byte[] value) {
    this.random_value = value;
  }

  public int getElection() {
    return this.id_election;
  }

  public String getAnswers() {
    return this.xml_answers;
  }

  public byte[] getRandomValue() {
    return this.random_value;
  }

  public AdministratorSignature[] getSignatures() {
    return this.signatures;
  }






}
