package inescID.revs.voter;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public class PanelButtonsControl extends JPanel {
  JButton ok = new JButton();
  JButton elections = new JButton();
  JButton cancel = new JButton();
  FlowLayout flowLayout1 = new FlowLayout();
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;

  public PanelButtonsControl() {
    try {
      jbInit();
      this.setOk();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    titledBorder1 = new TitledBorder("");
    titledBorder2 = new TitledBorder("");
    ok.setMaximumSize(new Dimension(85, 23));
    ok.setMinimumSize(new Dimension(85, 23));
    ok.setPreferredSize(new Dimension(85, 23));
    ok.setText("OK");
    this.setLayout(flowLayout1);
    elections.setMaximumSize(new Dimension(85, 23));
    elections.setMinimumSize(new Dimension(85, 23));
    elections.setPreferredSize(new Dimension(85, 23));
    elections.setText("Elections");
    cancel.setMaximumSize(new Dimension(85, 23));
    cancel.setMinimumSize(new Dimension(85, 23));
    cancel.setPreferredSize(new Dimension(85, 23));
    cancel.setText("Cancel");
    this.setBorder(BorderFactory.createEtchedBorder());
    this.setMinimumSize(new Dimension(249, 33));
    this.setPreferredSize(new Dimension(249, 33));
    flowLayout1.setHgap(5);
    flowLayout1.setVgap(3);
    this.add(elections, null);
    this.add(ok, null);
    this.add(cancel, null);
  }

  public void setOk(){
    this.elections.setVisible(false);
    this.elections.setEnabled(false);
    this.cancel.setVisible(false);
    this.cancel.setEnabled(false);
  }

  public void setOkCancel(){
    this.elections.setVisible(false);
    this.elections.setEnabled(false);
    this.cancel.setVisible(true);
    this.cancel.setEnabled(true);
  }

  public void setOkElections(){
    this.elections.setVisible(true);
    this.elections.setEnabled(true);
    this.cancel.setVisible(false);
    this.cancel.setEnabled(false);
  }

  public void setActionListener(IVoterEngine app) {
    cancel.addActionListener(new PanelButtonsControl_cancel_actionAdapter(app));
    elections.addActionListener(new PanelButtonsControl_elections_actionAdapter(app));
    ok.addActionListener(new PanelButtonsControl_ok_actionAdapter(app));
  }



}

class PanelButtonsControl_elections_actionAdapter implements java.awt.event.ActionListener {
  IVoterEngine adaptee;

  PanelButtonsControl_elections_actionAdapter(IVoterEngine adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.elections_actionPerformed(e);
  }
}

class PanelButtonsControl_ok_actionAdapter implements java.awt.event.ActionListener {
  IVoterEngine adaptee;

  PanelButtonsControl_ok_actionAdapter(IVoterEngine adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.ok_actionPerformed(e);
  }
}

class PanelButtonsControl_cancel_actionAdapter implements java.awt.event.ActionListener {
  IVoterEngine adaptee;

  PanelButtonsControl_cancel_actionAdapter(IVoterEngine adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cancel_actionPerformed(e);
  }
}
