package inescID.revs.voter;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public class PanelWelcome extends JPanel {
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel title = new JPanel();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JPanel jPanel1 = new JPanel();
  JTextPane welcome = new JTextPane();
  JScrollPane jScrollPane1 = new JScrollPane();

  public PanelWelcome() {
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    jLabel1.setFont(new java.awt.Font("Garamond", 1, 16));
    jLabel1.setText("A Robust Electronic Voting System");
    jLabel2.setFont(new java.awt.Font("Monotype Corsiva", 1, 26));
    jLabel2.setForeground(Color.black);
    jLabel2.setDebugGraphicsOptions(0);
    jLabel2.setHorizontalAlignment(SwingConstants.LEADING);
    jLabel2.setHorizontalTextPosition(SwingConstants.LEFT);
    jLabel2.setText("REVS");
    title.setLayout(gridBagLayout1);
    title.setForeground(new Color(55, 0, 220));
    title.setMinimumSize(new Dimension(298, 130));
    title.setPreferredSize(new Dimension(298, 130));
    this.setForeground(new Color(0, 0, 228));
    this.setPreferredSize(new Dimension(660, 490));
    welcome.setBackground(SystemColor.info);
    welcome.setBorder(BorderFactory.createEtchedBorder());
    welcome.setEditable(false);
    welcome.setText("");
    welcome.setContentType("text/html");
    //welcome.setColumns(90);
    //welcome.setLineWrap(true);
    //welcome.setRows(14);
    //welcome.setWrapStyleWord(true);
    jScrollPane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    jScrollPane1.setBorder(null);
    jScrollPane1.setPreferredSize(new Dimension(650, 300));
    this.add(title, BorderLayout.NORTH);
    title.add(jLabel2,                 new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(50, 0, 0, 5), 0, 0));
    title.add(jLabel1,         new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(0, 0, 20, 5), 0, 0));
    this.add(jPanel1,  BorderLayout.CENTER);
    jPanel1.add(jScrollPane1, null);
    jScrollPane1.getViewport().add(welcome, null);
  }

  public void setWelcomeMessage(String msg){
    this.welcome.setText(msg);
  }
}
