package inescID.revs.xml;

import java.util.Vector;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public class BallotQuestion {

  public static final int SINGLE_TYPE = 0;
  public static final int MULTIPLE_TYPE = 1;
  public static final int OPEN_SINGLE_TYPE = 2;
  public static final int OPEN_MULTIPLE_TYPE = 3;

  public static final String[] TYPES = {
      "Single",
      "Multiple",
      "OpenS",
      "OpenM"
  };

  int type;
  int code;
  String description;
  Vector options; //QuestionOption
  QuestionAnswer answer;

  public BallotQuestion() {
    options = new Vector();
  }

  public void setCode(int code) {
    this.code = code;
  }

  public int getCode() {
    return this.code;
  }

  public void setType(int type){
    this.type = type;
  }

  public void setType(String type){
    int i;
    for(i=0; i<TYPES.length; i++)
      if(TYPES[i].equals(type))
        break;

    if(i<TYPES.length)
      this.type = i;
  }

  public int getType(){
    return this.type;
  }

  public String getTypeString(){
    return TYPES[this.type];
  }

  public void setDescription(String description){
    this.description = description;
  }

  public String getDescription(){
    return this.description;
  }

  public void setOptions(Vector options){
    this.options = options;
  }

  public void addOption(QuestionOption option){
    this.options.add(option);
  }


  public Vector getOptions(){
    return this.options;
  }

  public void setAnswer(QuestionAnswer answer){
    this.answer = answer;
  }

  public QuestionAnswer getAnswer(){
    return this.answer;
  }
}
