package inescID.revs.xml;

import java.util.Vector;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public class QuestionAnswer {
  public static final int OPEN_ANSWER_CODE = 0;

  Vector answers; //Integer
  String open_answer=null;

//         <question code=5" answer=0-2-4">Open answer</question>

  public QuestionAnswer() {
    this.answers = new Vector();
  }

  public void setAnswers(Vector answers){
    this.answers = answers;
  }

  public void addAnswer(int code){
    if (code != OPEN_ANSWER_CODE)
      this.answers.add(new Integer(code));
  }

  public void setOpenAnswer(String answer){
    if(this.open_answer==null){
      this.open_answer = answer;
      this.answers.add(OPEN_ANSWER_CODE, new Integer(OPEN_ANSWER_CODE));
    }
  }

  public Vector getAnswers(){
    return this.answers;
  }

  public String getStringAnswers(){
    String answer = "";
    if (this.answers.size() < 1)
      return answer;
    answer += ((Integer) this.answers.get(0)).toString();
    for(int i=1; i< this.answers.size(); i++){
      answer += "-" + ((Integer) this.answers.get(i)).toString();
    }
    return answer;
  }

  public String getOpenAnswer(){
    return this.open_answer;
  }


}
