package inescID.revs.commissioner;

import java.awt.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.util.Vector;
import java.util.GregorianCalendar;
import java.util.Calendar;
import javax.swing.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */
import inescID.revs.util.Configuration;

public class ConfigurationAdministration extends JPanel {
  public static final byte NONE = 0;
  public static final byte UPDATE = 1;
  public static final byte NEW = 2;


  private byte state;
  private int selected_configuration;
  Vector configurations;
  Configuration configuration;



  Box box1;
  JPanel pTitle = new JPanel();
  JLabel title = new JLabel();
  JScrollPane listScrollPane = new JScrollPane();
  Component apace1;
  JButton New = new JButton();
  JButton ok = new JButton();
  JLabel lDescriptiton = new JLabel();
  JList selectionList = new JList();
  Box box3;
  JButton edit = new JButton();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  Component component2;
  Box box5;
  JComboBox number_of_administrators = new JComboBox();
  Component component3;
  JLabel lsignatures = new JLabel();
  JButton cancel = new JButton();
  BoxLayout2 pButtonsLayout1 = new BoxLayout2();
  JComboBox required_signatures = new JComboBox();
  JButton back = new JButton();
  JButton delete = new JButton();
  JLabel lstart = new JLabel();
  JPanel pMain = new JPanel();
  Component component1;
  JPanel jPanel1 = new JPanel();
  Component space2;
  JTextField description = new JTextField();
  Box mainBox;
  JLabel lAdministrators = new JLabel();
  Component space3;
  JPanel pButtons1 = new JPanel();
  JComboBox start_month = new JComboBox();
  JComboBox start_day = new JComboBox();
  JComboBox start_year = new JComboBox();
  JLabel lend = new JLabel();
  JComboBox end_month = new JComboBox();
  JComboBox end_day = new JComboBox();
  JComboBox end_year = new JComboBox();
  JComboBox start_hour = new JComboBox();
  JComboBox end_hour = new JComboBox();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JLabel jLabel6 = new JLabel();
  JCheckBox anonymizers = new JCheckBox();
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;


  public ConfigurationAdministration(Commissioner commi) {
    this.setActionListener(commi);
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
    init();
  }


  public ConfigurationAdministration() {
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
    init();
  }

  void init(){
    int i;
    //hour
    for (i = 0; i < 24; i++) {
      this.start_hour.addItem(new String(Integer.toString(i) + "h"));
      this.end_hour.addItem(new String(Integer.toString(i) + "h"));
    }


    //days
    for (i = 1; i <= 31; i++) {
      this.start_day.addItem(new Integer(i));
      this.end_day.addItem(new Integer(i));
    }

  //months
    for (i = 1; i <= 12; i++) {
      this.start_month.addItem(new Integer(i));
      this.end_month.addItem(new Integer(i));
    }

    //years
    Calendar calendar = GregorianCalendar.getInstance();
    i = calendar.get(Calendar.YEAR);
    int j = i + 10;
    i -= 10;
    for (; i < j; i++) {
      this.start_year.addItem(new Integer(i));
      this.end_year.addItem(new Integer(i));
    }


    for(i=1; i < 11; i++){
      this.number_of_administrators.addItem(new Integer(i));
      this.required_signatures.addItem(new Integer(i));
    }

  }

  void jbInit() throws Exception {
    box1 = Box.createVerticalBox();
    apace1 = Box.createVerticalStrut(25);
    box3 = Box.createVerticalBox();
    component2 = Box.createHorizontalStrut(81);
    box5 = Box.createVerticalBox();
    component3 = Box.createHorizontalStrut(8);
    component1 = Box.createVerticalStrut(13);
    space2 = Box.createVerticalStrut(41);
    mainBox = Box.createHorizontalBox();
    space3 = Box.createVerticalStrut(12);
    titledBorder1 = new TitledBorder("");
    titledBorder2 = new TitledBorder("");
    this.setEnabled(true);
    this.setMinimumSize(new Dimension(0, 0));

    this.setOpaque(true);
    this.setPreferredSize(new Dimension(0, 0));
    title.setFont(new java.awt.Font("Dialog", 0, 18));
    title.setMinimumSize(new Dimension(98, 15));
    title.setText("Configuration Administration");
    listScrollPane.setPreferredSize(new Dimension(200, 270));
    New.setText("New");
    New.addActionListener(new ConfigurationAdministration_New_actionAdapter(this));
    New.setSelected(false);
    New.setMnemonic('0');
    New.setHorizontalTextPosition(SwingConstants.CENTER);
    New.setMaximumSize(new Dimension(71, 23));
    ok.setText("OK");

    ok.setMnemonic('0');
    ok.setPreferredSize(new Dimension(65, 23));
    ok.setMinimumSize(new Dimension(65, 23));
    ok.setMaximumSize(new Dimension(65, 23));
    ok.setEnabled(false);
    lDescriptiton.setText("Description");
    edit.setEnabled(false);
    edit.setMaximumSize(new Dimension(71, 23));
    edit.setOpaque(true);
    edit.setHorizontalAlignment(SwingConstants.CENTER);
    edit.setHorizontalTextPosition(SwingConstants.CENTER);
    edit.setText("Edit");
    edit.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
    edit.setVerticalTextPosition(javax.swing.SwingConstants.CENTER);
    edit.addActionListener(new ConfigurationAdministration_edit_actionAdapter(this));
    lsignatures.setPreferredSize(new Dimension(98, 15));
    lsignatures.setText("Required Signatures");
    cancel.setEnabled(false);
    cancel.setHorizontalAlignment(SwingConstants.LEFT);
    cancel.setHorizontalTextPosition(SwingConstants.LEFT);
    cancel.setText("Cancel");
    cancel.addActionListener(new ConfigurationAdministration_cancel_actionAdapter(this));
    pButtonsLayout1.setAxis(BoxLayout.Y_AXIS);
    back.setMaximumSize(new Dimension(71, 23));
    back.setHorizontalTextPosition(SwingConstants.CENTER);
    back.setMargin(new Insets(2, 14, 2, 14));
    back.setText("Back");

    delete.setEnabled(false);
    delete.setMaximumSize(new Dimension(71, 23));
    delete.setHorizontalTextPosition(SwingConstants.CENTER);
    delete.setText("Delete");

    lstart.setToolTipText("");
    lstart.setText("Start (dd/mm/yyyy - hh)");
    jPanel1.setLayout(gridBagLayout1);
    description.setEditable(false);
    description.setText("");
    description.setColumns(40);
    lAdministrators.setOpaque(false);
    lAdministrators.setText("N. Admnistrators");
    pButtons1.setLayout(pButtonsLayout1);
    number_of_administrators.setEnabled(false);
    number_of_administrators.setMinimumSize(new Dimension(50, 19));
    number_of_administrators.setPreferredSize(new Dimension(50, 19));
    required_signatures.setEnabled(false);
    required_signatures.setMinimumSize(new Dimension(50, 19));
    required_signatures.setPreferredSize(new Dimension(50, 19));
    lend.setMaximumSize(new Dimension(114, 15));
    lend.setMinimumSize(new Dimension(114, 15));
    lend.setOpaque(false);
    lend.setPreferredSize(new Dimension(114, 15));
    lend.setRequestFocusEnabled(true);
    lend.setText("End (dd/mm/yyyy - hh)");
    start_day.setEnabled(false);
    start_day.setMinimumSize(new Dimension(50, 19));
    start_day.setPreferredSize(new Dimension(50, 19));
    end_day.setEnabled(false);
    end_day.setMinimumSize(new Dimension(50, 19));
    end_day.setPreferredSize(new Dimension(50, 19));
    start_month.setEnabled(false);
    start_month.setMinimumSize(new Dimension(50, 19));
    start_month.setPreferredSize(new Dimension(50, 19));
    end_month.setEnabled(false);
    end_month.setMinimumSize(new Dimension(50, 19));
    end_month.setPreferredSize(new Dimension(50, 19));
    end_year.setEnabled(false);
    end_year.setMinimumSize(new Dimension(50, 19));
    end_year.setPreferredSize(new Dimension(70, 19));
    start_year.setEnabled(false);
    start_year.setMinimumSize(new Dimension(70, 19));
    start_year.setPreferredSize(new Dimension(70, 19));
    end_hour.setEnabled(false);

    end_hour.setMinimumSize(new Dimension(50, 19));
    end_hour.setPreferredSize(new Dimension(50, 19));
    start_hour.setEnabled(false);

    start_hour.setMinimumSize(new Dimension(50, 19));
    start_hour.setPreferredSize(new Dimension(50, 19));
    jLabel1.setFont(new java.awt.Font("Dialog", 1, 14));
    jLabel1.setRequestFocusEnabled(true);
    jLabel1.setText("  /  ");
    jLabel2.setFont(new java.awt.Font("Dialog", 1, 14));
    jLabel2.setText("  /  ");
    jLabel3.setFont(new java.awt.Font("Dialog", 1, 14));
    jLabel3.setText("  /  ");
    jLabel4.setFont(new java.awt.Font("Dialog", 1, 14));
    jLabel4.setOpaque(false);
    jLabel4.setText("  /  ");
    jLabel5.setFont(new java.awt.Font("Dialog", 1, 14));
    jLabel5.setText("  -  ");
    jLabel6.setFont(new java.awt.Font("Dialog", 1, 14));
    jLabel6.setText("  -  ");
    anonymizers.setEnabled(false);
    anonymizers.setHorizontalTextPosition(SwingConstants.RIGHT);
    anonymizers.setText("Use Anonymizers");
    selectionList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    selectionList.addListSelectionListener(new ConfigurationAdministration_selectionList_listSelectionAdapter(this));
    box3.add(jPanel1, null);
    jPanel1.add(lAdministrators,                           new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 10, 5, 10), 0, 0));
    jPanel1.add(lstart,                                 new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 10, 5, 10), 0, 0));
    jPanel1.add(lDescriptiton,                          new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 0, 0, 0), 0, 0));
    jPanel1.add(description,                              new GridBagConstraints(1, 0, 7, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(10, 0, 5, 0), 0, 0));
    jPanel1.add(number_of_administrators,                          new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(start_month,                           new GridBagConstraints(3, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(start_day,                          new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(end_month,               new GridBagConstraints(3, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(end_day,               new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 0, 5, 0), 0, 0));
    jPanel1.add(lend,                     new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 10, 5, 10), 0, 0));
    jPanel1.add(end_year,              new GridBagConstraints(5, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(ok,                new GridBagConstraints(4, 4, 3, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(10, 10, 0, 0), 0, 0));
    jPanel1.add(start_hour,              new GridBagConstraints(7, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(end_hour,              new GridBagConstraints(7, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    this.add(box1, null);
    box1.add(pTitle, null);
    pTitle.add(title, null);
    box1.add(pMain, null);
    pMain.add(box3, null);
    box3.add(component1, null);
    box3.add(mainBox, null);
    mainBox.add(listScrollPane, null);
    mainBox.add(component2, null);
    mainBox.add(box5, null);
    mainBox.add(component3, null);
    box5.add(pButtons1, null);
    listScrollPane.getViewport().add(selectionList, null);
    pButtons1.add(space3, null);
    pButtons1.add(edit, null);
    pButtons1.add(New, null);
    pButtons1.add(delete, null);
    pButtons1.add(space2, null);
    pButtons1.add(back, null);
    pButtons1.add(apace1, null);
    jPanel1.add(jLabel1,           new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel2,           new GridBagConstraints(4, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel3,         new GridBagConstraints(2, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel4,        new GridBagConstraints(4, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel5,        new GridBagConstraints(6, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel6,      new GridBagConstraints(6, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(lsignatures,   new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 10, 5, 0), 0, 0));
    jPanel1.add(required_signatures,   new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(start_year,  new GridBagConstraints(5, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(cancel,   new GridBagConstraints(7, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(10, 0, 0, 20), 0, 0));
    jPanel1.add(anonymizers,    new GridBagConstraints(3, 3, 5, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 10, 0, 0), 0, 0));
  }


  public void releaseMemory(){
     this.configurations = null;
     this.configuration=null;
     this.selectionList.removeAll();

 }


  public byte getState(){
    return this.state;
  }

  public void updateList(Vector configurations){
    this.configurations = configurations;
    this.disable_edit();
    this.disable_actions();
    this.clear_edition();
    this.back.setEnabled(true);
    this.New.setEnabled(true);

    Vector aux = new Vector(this.configurations.size());
    for(int i=0; i < this.configurations.size(); i++){
      aux.add(((Configuration) this.configurations.get(i)).GetDescription());
    }

    this.selectionList.setListData(aux);


    if (this.state != ConfigurationAdministration.NONE){
      int index;
      if (this.state == ConfigurationAdministration.UPDATE)
        index = this.selected_configuration;
      else
        index = this.configurations.size()-1;

      this.selectionList.setSelectedIndex(index);
      this.selectionList.ensureIndexIsVisible(index);
    }

    this.state = ConfigurationAdministration.NONE;
  }


  public Configuration getConfiguration(){
    Configuration configuration;
    if (this.state == ConfigurationAdministration.NEW)
      configuration = new Configuration();
    else
      configuration = (Configuration) this.configurations.get(this.selectionList.getSelectedIndex());

    this.selected_configuration = this.selectionList.getSelectedIndex();

    configuration.SetDescription(this.description.getText());
    configuration.SetUseAnonymizers(this.anonymizers.isSelected());
    configuration.SetReqAdministrators(this.number_of_administrators.getSelectedIndex() + 1);
    configuration.SetReqSignatures(this.required_signatures.getSelectedIndex() + 1);
    long start, end;
    GregorianCalendar calendar = new GregorianCalendar(
      ((Integer) this.start_year.getSelectedItem()).intValue(),
      this.start_month.getSelectedIndex(),
      this.start_day.getSelectedIndex() +1,
      this.start_hour.getSelectedIndex(), 0);
    start = calendar.getTimeInMillis();
    configuration.SetStart(start);

    calendar = new GregorianCalendar(((Integer) this.end_year.getSelectedItem()).intValue(),
                                     this.end_month.getSelectedIndex(),
                                     this.end_day.getSelectedIndex() +1,
                                     this.end_hour.getSelectedIndex(), 0);

    end = calendar.getTimeInMillis();
    configuration.SetEnd(end);


    return configuration;
  }

  void enable_actions(){
    this.back.setEnabled(true);
    this.delete.setEnabled(true);
    this.New.setEnabled(true);
    this.edit.setEnabled(true);
  }

  void disable_actions(){
    this.back.setEnabled(false);
    this.delete.setEnabled(false);
    this.New.setEnabled(false);
    this.edit.setEnabled(false);
  }

  void enable_edit(){
    this.disable_actions();
    this.description.setEditable(true);
    this.start_day.setEnabled(true);
    this.start_month.setEnabled(true);
    this.start_year.setEnabled(true);
    this.start_hour.setEnabled(true);
    this.end_day.setEnabled(true);
    this.end_month.setEnabled(true);
    this.end_year.setEnabled(true);
    this.end_hour.setEnabled(true);
    this.anonymizers.setEnabled(true);
    this.number_of_administrators.setEnabled(true);
    this.required_signatures.setEnabled(true);
    this.ok.setEnabled(true);
    this.cancel.setEnabled(true);
  }

  void disable_edit(){

    this.description.setEditable(false);
    this.start_day.setEnabled(false);
    this.start_month.setEnabled(false);
    this.start_year.setEnabled(false);
    this.start_hour.setEnabled(false);
    this.end_day.setEnabled(false);
    this.end_month.setEnabled(false);
    this.end_year.setEnabled(false);
    this.end_hour.setEnabled(false);
    this.anonymizers.setEnabled(false);
    this.number_of_administrators.setEnabled(false);
    this.required_signatures.setEnabled(false);
    this.ok.setEnabled(false);
    this.cancel.setEnabled(false);

    this.enable_actions();
  }

  void clear_edition(){
    this.description.setText("");
    this.start_day.setSelectedIndex(-1);
    this.start_month.setSelectedIndex(-1);
    this.start_year.setSelectedIndex(-1);
    this.start_hour.setSelectedIndex(-1);
    this.end_day.setSelectedIndex(-1);
    this.end_month.setSelectedIndex(-1);
    this.end_year.setSelectedIndex(-1);
    this.end_hour.setSelectedIndex(-1);
    this.anonymizers.setSelected(true);
    this.number_of_administrators.setSelectedIndex(-1);
    this.required_signatures.setSelectedIndex(-1);
  }

  public void setActionListener(Commissioner commi) {
    back.addActionListener(new ConfigurationAdministration_back_actionAdapter(commi));
    delete.addActionListener(new ConfigurationAdministration_delete_actionAdapter(commi));
    ok.addActionListener(new ConfigurationAdministration_ok_actionAdapter(commi));
  }

  void edit_actionPerformed(ActionEvent e) {
    this.state = ConfigurationAdministration.UPDATE;
    this.enable_edit();
  }

  void New_actionPerformed(ActionEvent e) {
    this.state = ConfigurationAdministration.NEW;
    this.clear_edition();
    this.enable_edit();
  }

  void cancel_actionPerformed(ActionEvent e) {
    this.state = ConfigurationAdministration.NONE;
    this.disable_edit();
    this.selectionList_valueChanged(null);
  }

  void selectionList_valueChanged(ListSelectionEvent e) {
    if (this.selectionList.getSelectedIndex() >= 0) {
      this.configuration =
          (Configuration)this.configurations.get(this.selectionList.getSelectedIndex());

      this.description.setText(this.configuration.GetDescription());
      this.anonymizers.setSelected(this.configuration.UseAnonymizers());
      this.number_of_administrators.setSelectedIndex(
          this.configuration.GetReqAdministrators() - 1);
      this.required_signatures.setSelectedIndex(
          this.configuration.GetReqSignatures() - 1);

      GregorianCalendar calendar = new GregorianCalendar();
      calendar.setTimeInMillis(this.configuration.GetStart());
      this.start_day.setSelectedIndex(calendar.get(Calendar.DAY_OF_MONTH) - 1);
      this.start_month.setSelectedIndex(calendar.get(Calendar.MONTH));
      this.start_year.setSelectedItem(new Integer(calendar.get(Calendar.YEAR)));
      this.start_hour.setSelectedIndex(calendar.get(Calendar.HOUR_OF_DAY));

      calendar.setTimeInMillis(this.configuration.GetEnd());
      this.end_day.setSelectedIndex(calendar.get(Calendar.DAY_OF_MONTH) - 1);
      this.end_month.setSelectedIndex(calendar.get(Calendar.MONTH));
      this.end_year.setSelectedItem(new Integer(calendar.get(Calendar.YEAR)));
      this.end_hour.setSelectedIndex(calendar.get(Calendar.HOUR_OF_DAY));
    }

    this.enable_actions();
  }






}

class ConfigurationAdministration_back_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  ConfigurationAdministration_back_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.CAback_actionPerformed(e);
  }
}

class ConfigurationAdministration_delete_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  ConfigurationAdministration_delete_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.CAdelete_actionPerformed(e);
  }
}

class ConfigurationAdministration_ok_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  ConfigurationAdministration_ok_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.CAok_actionPerformed(e);
  }
}

class ConfigurationAdministration_edit_actionAdapter implements java.awt.event.ActionListener {
  ConfigurationAdministration adaptee;

  ConfigurationAdministration_edit_actionAdapter(ConfigurationAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.edit_actionPerformed(e);
  }
}

class ConfigurationAdministration_New_actionAdapter implements java.awt.event.ActionListener {
  ConfigurationAdministration adaptee;

  ConfigurationAdministration_New_actionAdapter(ConfigurationAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.New_actionPerformed(e);
  }
}

class ConfigurationAdministration_cancel_actionAdapter implements java.awt.event.ActionListener {
  ConfigurationAdministration adaptee;

  ConfigurationAdministration_cancel_actionAdapter(ConfigurationAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cancel_actionPerformed(e);
  }
}

class ConfigurationAdministration_selectionList_listSelectionAdapter implements javax.swing.event.ListSelectionListener {
  ConfigurationAdministration adaptee;

  ConfigurationAdministration_selectionList_listSelectionAdapter(ConfigurationAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void valueChanged(ListSelectionEvent e) {
    adaptee.selectionList_valueChanged(e);
  }
}


