package inescID.revs.commissioner;

import java.awt.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.event.*;
/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */
import inescID.revs.util.*;

public class ElectionAdministration extends JPanel {

  public static final byte NONE = 0;
  public static final byte UPDATE = 1;
  public static final byte NEW = 2;

  private byte state;
  private Election election;
  private Vector elections;
  private int active_index;

  private Vector voters_groups;
  private Vector configurations;


  private Frame parent;

  Box box1;
  JPanel pTitle = new JPanel();
  JLabel title = new JLabel();
  JPanel pMain = new JPanel();
  Box mainBox;
  JScrollPane listScrollPane = new JScrollPane();
  JList selectionList = new JList();
  Component apace1;
  JButton New = new JButton();
  JButton ok = new JButton();
  JPanel pButtons1 = new JPanel();
  JButton back = new JButton();
  JButton delete = new JButton();
  BoxLayout2 pButtonsLayout1 = new BoxLayout2();
  JLabel lConfiguration = new JLabel();
  JPanel jPanel1 = new JPanel();
  JButton edit = new JButton();
  Box box5;
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  Component space2;
  Component space3;
  JButton cancel = new JButton();
  JLabel lVotersGroup = new JLabel();
  JLabel lBallot = new JLabel();
  JLabel lDescriptiton = new JLabel();
  JTextField description = new JTextField();
  JComboBox voters_group_list = new JComboBox();
  JComboBox configurations_list = new JComboBox();
  JTextField ballot = new JTextField();
  JButton ballot_file_chooser = new JButton();
  Box box3;
  Component component1;
  Component component2;
  Component component3;

  public ElectionAdministration(Frame parent, Commissioner commi) {
    this.parent = parent;
    this.setActionListener(commi);
    this.state = ElectionAdministration.NONE;
    this.clear_edition();

    try {
        jbInit();
      }
      catch(Exception ex) {
        ex.printStackTrace();
      }
    }


  public ElectionAdministration() {
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    box1 = Box.createVerticalBox();
    mainBox = Box.createHorizontalBox();
    apace1 = Box.createVerticalStrut(25);
    box5 = Box.createVerticalBox();
    space2 = Box.createVerticalStrut(41);
    space3 = Box.createVerticalStrut(12);
    box3 = Box.createVerticalBox();
    component1 = Box.createVerticalStrut(13);
    component2 = Box.createHorizontalStrut(81);
    component3 = Box.createHorizontalStrut(8);
    this.setEnabled(true);
    this.setForeground(Color.black);
    this.setMinimumSize(new Dimension(0, 0));

    this.setOpaque(true);
    this.setPreferredSize(new Dimension(0, 0));
    title.setFont(new java.awt.Font("Dialog", 0, 18));
    title.setAlignmentY((float) 0.5);
    title.setMinimumSize(new Dimension(98, 15));
    title.setText("Election Administration");
    listScrollPane.setPreferredSize(new Dimension(200, 270));

    New.setText("New");
    New.addActionListener(new ElectionAdministration_New_actionAdapter(this));
    New.setSelected(false);
    New.setMnemonic('0');
    New.setHorizontalTextPosition(SwingConstants.CENTER);
    New.setMaximumSize(new Dimension(71, 23));
    ok.setText("OK");

    ok.setMnemonic('0');
    ok.setPreferredSize(new Dimension(65, 23));
    ok.setMinimumSize(new Dimension(65, 23));
    ok.setMaximumSize(new Dimension(65, 23));
    ok.setEnabled(false);
    pButtons1.setLayout(pButtonsLayout1);
    back.setMaximumSize(new Dimension(71, 23));
    back.setHorizontalTextPosition(SwingConstants.CENTER);
    back.setMargin(new Insets(2, 14, 2, 14));
    back.setText("Back");

    delete.setEnabled(false);
    delete.setMaximumSize(new Dimension(71, 23));
    delete.setHorizontalTextPosition(SwingConstants.CENTER);
    delete.setText("Delete");

    pButtonsLayout1.setAxis(BoxLayout.Y_AXIS);
    lConfiguration.setText("Configuration");
    jPanel1.setLayout(gridBagLayout1);
    edit.setEnabled(false);
    edit.setMaximumSize(new Dimension(71, 23));
    edit.setOpaque(true);
    edit.setHorizontalAlignment(SwingConstants.CENTER);
    edit.setHorizontalTextPosition(SwingConstants.CENTER);
    edit.setText("Edit");
    edit.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
    edit.setVerticalTextPosition(javax.swing.SwingConstants.CENTER);
    edit.addActionListener(new ElectionAdministration_edit_actionAdapter(this));

    cancel.setEnabled(false);
    cancel.setText("Cancel");
    cancel.addActionListener(new ElectionAdministration_cancel_actionAdapter(this));

    lVotersGroup.setText("Voters Group");
    lBallot.setText("Ballot");
    lDescriptiton.setText("Description");
    description.setEditable(false);
    description.setText("");
    description.setColumns(40);
    ballot_file_chooser.setEnabled(false);
    ballot_file_chooser.setText("Browse");
    ballot_file_chooser.addActionListener(new ElectionAdministration_ballot_file_chooser_actionAdapter(this));
    ballot.setEditable(false);
    ballot.setSelectionStart(0);
    ballot.setText("");
    ballot.setColumns(35);
    configurations_list.setEnabled(false);
    selectionList.addListSelectionListener(new ElectionAdministration_selectionList_listSelectionAdapter(this));
    voters_group_list.setEnabled(false);
    selectionList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    this.add(box1, null);
    box1.add(pTitle, null);
    pTitle.add(title, null);
    box1.add(pMain, null);
    pMain.add(box3, null);
    box3.add(jPanel1, null);
    mainBox.add(listScrollPane, null);
    mainBox.add(component2, null);
    mainBox.add(box5, null);
    box5.add(pButtons1, null);
    mainBox.add(component3, null);
    listScrollPane.getViewport().add(selectionList, null);
    jPanel1.add(lConfiguration,             new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(10, 10, 10, 10), 0, 0));
    jPanel1.add(ok,               new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(10, 150, 0, 10), 0, 0));
    jPanel1.add(cancel,                     new GridBagConstraints(2, 4, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(10, 0, 0, 0), 0, 0));
    jPanel1.add(lVotersGroup, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(lBallot, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 0, 10, 0), 0, 0));
    jPanel1.add(lDescriptiton,  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 0, 0, 0), 0, 0));
    jPanel1.add(description,   new GridBagConstraints(1, 0, 3, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(10, 0, 0, 0), 0, 0));
    jPanel1.add(voters_group_list, new GridBagConstraints(1, 2, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(configurations_list, new GridBagConstraints(1, 3, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(ballot,   new GridBagConstraints(1, 1, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 5), 0, 0));
    jPanel1.add(ballot_file_chooser, new GridBagConstraints(3, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    box3.add(component1, null);
    box3.add(mainBox, null);
    pButtons1.add(space3, null);
    pButtons1.add(edit, null);
    pButtons1.add(New, null);
    pButtons1.add(delete, null);
    pButtons1.add(space2, null);
    pButtons1.add(back, null);
    pButtons1.add(apace1, null);
  }



  public void releaseMemory(){
    this.elections = null;
    this.election=null;
    this.selectionList.removeAll();

    this.voters_groups = null;
    this.voters_group_list.removeAllItems();
    this.configurations = null;
    this.configurations_list.removeAllItems();

}

  public void updateList(Vector elections){

    this.exit_edition_mode();
    this.clear_edition();
    this.disable_actions();
    this.back.setEnabled(true);
    this.New.setEnabled(true);


    this.elections = elections;
    Vector aux = new Vector(this.elections.size());

    Election election;
    for(int i=0; i < this.elections.size(); i++){
      election = (Election) this.elections.get(i);
      aux.add(election.GetDescription());
    }



    if (this.state==ElectionAdministration.NEW)
     this.active_index = aux.size()-1;
   else
     if (this.state==ElectionAdministration.NONE) //delete or first time
       this.active_index = -1;

    int index = this.active_index;

    this.selectionList.setListData(aux);

    if (index != -1) {
      this.selectionList.setSelectedIndex(index);
      this.selectionList.ensureIndexIsVisible(index);
    }


    this.state = ElectionAdministration.NONE;

   // this.changeElection();

  }

  public void init(Vector elections, Vector groups, Vector configurations){
    this.updateList(elections);

    this.voters_groups = groups;
    this.configurations = configurations;

    IdDescription element;
    this.voters_group_list.removeAllItems();
    for(int i=0; i < this.voters_groups.size(); i++){
      element = (IdDescription) this.voters_groups.get(i);
      this.voters_group_list.addItem(element.GetDescription());
    }

    this.configurations_list.removeAllItems();
    for(int i=0; i < this.configurations.size(); i++){
      element = (IdDescription) this.configurations.get(i);
      this.configurations_list.addItem(element.GetDescription());
    }


  }

  public byte getState(){
    return this.state;
  }

  public Election getElection(){
    if (this.state == ElectionAdministration.NEW){
      this.election = new Election();
      //this.election.SetKey(null);
    }

    this.election.SetDescription(this.description.getText());
    this.election.SetBallot(this.ballot.getText());
    this.election.SetIdVotersGroup(
      ((IdDescription) this.voters_groups.get(this.voters_group_list.getSelectedIndex())).GetId());
    this.election.SetConfiguration(
      ((IdDescription) this.configurations.get(this.configurations_list.getSelectedIndex())).GetId());


    return this.election;
  }

  void changeElection(){
    if (this.active_index >= 0){

      this.election = (Election) this.elections.get(this.active_index);

      this.description.setText(this.election.GetDescription());
      this.ballot.setText(this.election.GetBallot());

      int index=0;
      IdDescription group;
      for(index=0; index < this.voters_groups.size(); index++){
        group = (IdDescription) this.voters_groups.get(index);
        if (group.GetId() == this.election.GetIdVotersGroup())
          break;
      }
      if (index < this.voters_groups.size())
        this.voters_group_list.setSelectedIndex(index);

      IdDescription configuration;
      for(index=0; index < this.configurations.size(); index++){
        configuration = (IdDescription) this.configurations.get(index);
        if (configuration.GetId() == this.election.GetIdConfiguration())
          break;
      }
      if (index < this.configurations.size())
        this.configurations_list.setSelectedIndex(index);

      this.enable_actions();
    }
    else{
      disable_actions();
      this.New.setEnabled(true);
      this.back.setEnabled(true);
    }



  }

  void clear_edition(){
    this.description.setText("");
    this.ballot.setText("");
    this.voters_group_list.setSelectedIndex(-1);
    this.configurations_list.setSelectedIndex(-1);
  }

  void cancel_actionPerformed(ActionEvent e) {
    this.exit_edition_mode();
    this.changeElection();
    this.state = ElectionAdministration.NONE;
  }


  void edit_actionPerformed(ActionEvent e) {
    this.state = ElectionAdministration.UPDATE;
    this.enter_edition_mode();
  }

  void New_actionPerformed(ActionEvent e) {
    this.state = ElectionAdministration.NEW;
    this.clear_edition();
    this.enter_edition_mode();
  }

  void ballot_file_chooser_actionPerformed(ActionEvent e) {
    FileDialog f = new FileDialog(this.parent, "Select ballot", FileDialog.LOAD);
    f.show();
    if ( (f.getDirectory() != null) && (f.getFile() != null)) {
      this.ballot.setText(f.getDirectory() + f.getFile());
    }
  }



  void enable_actions(){
    this.edit.setEnabled(true);
    this.New.setEnabled(true);
    this.delete.setEnabled(true);
    this.back.setEnabled(true);

  }

  void disable_actions(){
    this.edit.setEnabled(false);
    this.New.setEnabled(false);
    this.delete.setEnabled(false);
    this.back.setEnabled(false);
  }

  void enter_edition_mode(){
    this.disable_actions();
    this.selectionList.setEnabled(false);

    this.description.setEditable(true);
    this.ballot.setEditable(true);
    this.ballot_file_chooser.setEnabled(true);
    this.voters_group_list.setEnabled(true);
    this.configurations_list.setEnabled(true);
    this.ok.setEnabled(true);
    this.cancel.setEnabled(true);
  }

  void exit_edition_mode(){
    this.ok.setEnabled(false);
    this.cancel.setEnabled(false);
    this.description.setEditable(false);
    this.ballot.setEditable(false);
    this.ballot_file_chooser.setEnabled(false);
    this.voters_group_list.setEnabled(false);
    this.configurations_list.setEnabled(false);

    this.selectionList.setEnabled(true);
    this.enable_actions();
  }


  public void setActionListener(Commissioner commi) {
    back.addActionListener(new ElectionAdministration_back_actionAdapter(commi));
    delete.addActionListener(new ElectionAdministration_delete_actionAdapter(commi));
    ok.addActionListener(new ElectionAdministration_ok_actionAdapter(commi));
  }

  void selectionList_valueChanged(ListSelectionEvent e) {
    if (this.state==ElectionAdministration.NONE)
      this.active_index = this.selectionList.getSelectedIndex();
    this.changeElection();
  }


}

class ElectionAdministration_ballot_file_chooser_actionAdapter implements java.awt.event.ActionListener {
  ElectionAdministration adaptee;

  ElectionAdministration_ballot_file_chooser_actionAdapter(ElectionAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.ballot_file_chooser_actionPerformed(e);
  }
}

class ElectionAdministration_cancel_actionAdapter implements java.awt.event.ActionListener {
  ElectionAdministration adaptee;

  ElectionAdministration_cancel_actionAdapter(ElectionAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cancel_actionPerformed(e);
  }
}

class ElectionAdministration_ok_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  ElectionAdministration_ok_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.EAok_actionPerformed(e);
  }
}

class ElectionAdministration_edit_actionAdapter implements java.awt.event.ActionListener {
  ElectionAdministration adaptee;

  ElectionAdministration_edit_actionAdapter(ElectionAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.edit_actionPerformed(e);
  }
}

class ElectionAdministration_New_actionAdapter implements java.awt.event.ActionListener {
  ElectionAdministration adaptee;

  ElectionAdministration_New_actionAdapter(ElectionAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.New_actionPerformed(e);
  }
}

class ElectionAdministration_delete_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  ElectionAdministration_delete_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.EAdelete_actionPerformed(e);
  }
}

class ElectionAdministration_back_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  ElectionAdministration_back_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.EAback_actionPerformed(e);
  }
}

class ElectionAdministration_selectionList_listSelectionAdapter implements javax.swing.event.ListSelectionListener {
  ElectionAdministration adaptee;

  ElectionAdministration_selectionList_listSelectionAdapter(ElectionAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void valueChanged(ListSelectionEvent e) {
    adaptee.selectionList_valueChanged(e);
  }
}


