package inescID.revs.commissioner;

import java.awt.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.util.Vector;



/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

import inescID.revs.util.Server;


public class ServersAdministration extends JPanel {
  public static final byte NONE = 0;
  public static final byte UPDATE = 1;

  private byte state;
  private int selection;


  public static final byte DISTRIBUTOR = 0;
  public static final byte ADMINISTRATOR = 1;
  public static final byte ANONYMIZER = 2;
  public static final byte COUNTER = 3;

  Vector[] server_list = new Vector[4];
  JList[] server_selection = new JList[4];

  Box box1;
  JPanel pTitle = new JPanel();
  JLabel title = new JLabel();
  JLabel ldescription = new JLabel();
  JLabel lURL = new JLabel();
  JPanel Administrators = new JPanel();
  JTextField description = new JTextField();
  JTabbedPane servers = new JTabbedPane();
  JTextField URL = new JTextField();
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;
  TitledBorder titledBorder3;
  JPanel Distributors = new JPanel();
  JPanel Anonymizers = new JPanel();
  JPanel Counters = new JPanel();
  JScrollPane jScrollPane1 = new JScrollPane();
  JList distributors_selection = new JList();
  Box box2;
  Box box3;
  JPanel jPanelEdit = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JPanel jPanelButtons = new JPanel();
  JButton edit = new JButton();
  BoxLayout2 boxLayout21 = new BoxLayout2();
  JButton back = new JButton();
  JButton ok = new JButton();
  JButton cancel = new JButton();
  Component component1;
  Component component2;
  JScrollPane jScrollPane2 = new JScrollPane();
  JList administrators_selection = new JList();
  JScrollPane jScrollPane3 = new JScrollPane();
  JList anonymizers_selection = new JList();
  JScrollPane jScrollPane4 = new JScrollPane();
  JList counters_selection = new JList();
  JCheckBox enable = new JCheckBox();
  JButton load_key = new JButton();




  public ServersAdministration(Commissioner commi) {
    this.init();
    this.setActionListener(commi) ;
  }

  void init(){
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }

    this.server_selection[DISTRIBUTOR] = this.distributors_selection;
    this.server_selection[ADMINISTRATOR] = this.administrators_selection;
    this.server_selection[ANONYMIZER] = this.anonymizers_selection;
    this.server_selection[COUNTER] = this.counters_selection;

    this.state = ServersAdministration.NONE;
  }


  public ServersAdministration() {
    this.init();
  }

  void jbInit() throws Exception {
    box1 = Box.createVerticalBox();
    titledBorder1 = new TitledBorder("");
    titledBorder2 = new TitledBorder("");
    titledBorder3 = new TitledBorder("");
    box2 = Box.createVerticalBox();
    box3 = Box.createHorizontalBox();
    component1 = Box.createVerticalStrut(40);
    component2 = Box.createVerticalStrut(22);
    this.setEnabled(true);
    this.setMinimumSize(new Dimension(0, 0));

    this.setOpaque(true);
    this.setPreferredSize(new Dimension(0, 0));
    title.setFont(new java.awt.Font("Dialog", 0, 18));
    title.setMinimumSize(new Dimension(98, 15));
    title.setText("Servers Administration");
    ldescription.setHorizontalAlignment(SwingConstants.LEFT);
    ldescription.setHorizontalTextPosition(SwingConstants.CENTER);
    ldescription.setText("Description");
    lURL.setPreferredSize(new Dimension(98, 15));
    lURL.setHorizontalAlignment(SwingConstants.LEFT);
    lURL.setHorizontalTextPosition(SwingConstants.CENTER);
    lURL.setText("URL");
    description.setEnabled(true);
    description.setEditable(false);
    description.setText("");
    description.setColumns(30);
    Administrators.setMinimumSize(new Dimension(395, 350));
    Administrators.setPreferredSize(new Dimension(465, 350));
    Administrators.addFocusListener(new ServersAdministration_Administrators_focusAdapter(this));
    servers.setTabPlacement(JTabbedPane.TOP);
    servers.setMinimumSize(new Dimension(250, 350));
    servers.setPreferredSize(new Dimension(250, 350));
    servers.setRequestFocusEnabled(true);
    URL.setColumns(30);
    URL.setText("");
    URL.setEnabled(true);
    URL.setEditable(false);
    Distributors.setAlignmentX((float) 0.5);
    Distributors.setMinimumSize(new Dimension(0, 0));
    Distributors.setPreferredSize(new Dimension(0, 0));
    Distributors.addFocusListener(new ServersAdministration_Distributors_focusAdapter(this));
    jScrollPane1.setMinimumSize(new Dimension(200, 300));
    jScrollPane1.setPreferredSize(new Dimension(235, 300));
    jPanelEdit.setLayout(gridBagLayout1);
    edit.setMaximumSize(new Dimension(65, 23));
    edit.setMinimumSize(new Dimension(65, 23));
    edit.setPreferredSize(new Dimension(65, 23));
    edit.setText("Edit");
    edit.addActionListener(new ServersAdministration_edit_actionAdapter(this));
    jPanelButtons.setLayout(boxLayout21);
    boxLayout21.setAxis(BoxLayout.Y_AXIS);
    back.setMaximumSize(new Dimension(65, 23));
    back.setMinimumSize(new Dimension(65, 23));
    back.setPreferredSize(new Dimension(65, 23));
    back.setText("Back");
    ok.setMaximumSize(new Dimension(65, 23));
    ok.setMinimumSize(new Dimension(65, 23));
    ok.setPreferredSize(new Dimension(65, 23));
    ok.setText("OK");
    cancel.setActionCommand("Cancel");
    cancel.setText("Cancel");
    cancel.addActionListener(new ServersAdministration_cancel_actionAdapter(this));
    jScrollPane2.setPreferredSize(new Dimension(235, 300));
    jScrollPane2.setMinimumSize(new Dimension(200, 300));
    jScrollPane3.setMinimumSize(new Dimension(200, 300));
    jScrollPane3.setPreferredSize(new Dimension(235, 300));
    jScrollPane4.setMinimumSize(new Dimension(200, 300));
    jScrollPane4.setPreferredSize(new Dimension(235, 300));
    jScrollPane4.setRequestFocusEnabled(true);
    distributors_selection.addListSelectionListener(new ServersAdministration_distributors_selection_listSelectionAdapter(this));
    administrators_selection.addListSelectionListener(new ServersAdministration_administrators_selection_listSelectionAdapter(this));
    anonymizers_selection.addListSelectionListener(new ServersAdministration_anonymizers_selection_listSelectionAdapter(this));
    counters_selection.addListSelectionListener(new ServersAdministration_counters_selection_listSelectionAdapter(this));
    enable.setEnabled(false);
    enable.setText("Enable");
    Anonymizers.addFocusListener(new ServersAdministration_Anonymizers_focusAdapter(this));
    Counters.addFocusListener(new ServersAdministration_Counters_focusAdapter(this));
    load_key.setText("Load Key");
    this.add(box1, null);
    box1.add(pTitle, null);
    pTitle.add(title, null);
    box1.add(box3, null);
    box3.add(servers, null);

    servers.add(Distributors, "Distributors", DISTRIBUTOR);
    servers.add(Administrators, "Administrators", ADMINISTRATOR);
    servers.add(Anonymizers, "Anonymizers", ANONYMIZER);
    servers.add(Counters, "Counters", COUNTER);

    Distributors.add(jScrollPane1, null);
    box3.add(box2, null);
    box2.add(jPanelEdit, null);
    jPanelEdit.add(lURL,                new GridBagConstraints(0, 2, 3, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(10, 10, 0, 0), 0, 0));
    jPanelEdit.add(ldescription,            new GridBagConstraints(0, 0, 3, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 10, 0, 0), 0, 0));
    jPanelEdit.add(description,           new GridBagConstraints(0, 1, 3, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 10, 0, 0), 0, 0));
    jPanelEdit.add(URL,          new GridBagConstraints(0, 3, 3, 1, 1.0, 0.0
            ,GridBagConstraints.SOUTHWEST, GridBagConstraints.HORIZONTAL, new Insets(5, 10, 0, 0), 0, 0));
    jPanelEdit.add(ok,                 new GridBagConstraints(1, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 30, 0, 0), 0, 0));
    jPanelEdit.add(cancel,      new GridBagConstraints(2, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 10, 0, 0), 0, 0));
    jPanelEdit.add(enable,  new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 10, 0, 0), 0, 0));
    jPanelEdit.add(load_key,  new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 10, 0, 0), 0, 0));
    box2.add(jPanelButtons, null);
    jPanelButtons.add(edit, null);
    jPanelButtons.add(component2, null);
    jPanelButtons.add(back, null);
    jPanelButtons.add(component1, null);
    jScrollPane1.getViewport().add(distributors_selection, null);
    Administrators.add(jScrollPane2, null);
    jScrollPane2.getViewport().add(administrators_selection, null);
    Anonymizers.add(jScrollPane3, null);
    jScrollPane3.getViewport().add(anonymizers_selection, null);
    Counters.add(jScrollPane4, null);
    jScrollPane4.getViewport().add(counters_selection, null);

  }

  public void releaseMemory(){

    Vector[] server_list = new Vector[4];
    server_selection[DISTRIBUTOR].removeAll();
    server_selection[ADMINISTRATOR].removeAll();
    server_selection[ANONYMIZER].removeAll();
    server_selection[COUNTER].removeAll();

   }


  public void updateLists(Vector distributors, Vector administrators,
                         Vector anonymizers, Vector counters) {
   this.selection = -1;
   this.state = ServersAdministration.NONE;
   this.updateDistributorsList(distributors);
   this.updateAdministratorsList(administrators);
   this.updateAnonymizersList(anonymizers);
   this.updateCountersList(counters);

   this.ok.setEnabled(false);
   this.load_key.setEnabled(false);
   this.cancel.setEnabled(false);
   this.description.setEditable(false);
   this.URL.setEditable(false);
   this.enable.setEnabled(false);

   this.description.setText("");
   this.URL.setText("");
   this.enable.setSelected(false);

    }

  public void updateDistributorsList(Vector distributors) {

    this.server_list[DISTRIBUTOR] = distributors;
    Vector aux;
    Server server;
    aux = new Vector(this.server_list[DISTRIBUTOR].size());
    for (int i = 0; i < this.server_list[DISTRIBUTOR].size(); i++) {
      server = (Server)this.server_list[DISTRIBUTOR].get(i);
      aux.add(server.GetDescription());
    }
    this.server_selection[DISTRIBUTOR].setListData(aux);
    this.setSelected();
  }

  public void updateAdministratorsList(Vector administrators) {
    this.server_list[ADMINISTRATOR] = administrators;
    Vector aux;
    Server server;
    aux = new Vector(this.server_list[ADMINISTRATOR].size());
    for (int i = 0; i < this.server_list[ADMINISTRATOR].size(); i++) {
      server = (Server)this.server_list[ADMINISTRATOR].get(i);
      aux.add(server.GetDescription());
    }
    this.server_selection[ADMINISTRATOR].setListData(aux);
    this.setSelected();
  }

  public void updateAnonymizersList(Vector anonymizers) {
    this.server_list[ANONYMIZER] = anonymizers;
    Vector aux;
    Server server;
    aux = new Vector(this.server_list[ANONYMIZER].size());
    for (int i = 0; i < this.server_list[ANONYMIZER].size(); i++) {
      server = (Server)this.server_list[ANONYMIZER].get(i);
      aux.add(server.GetDescription());
    }
    this.server_selection[ANONYMIZER].setListData(aux);
    this.setSelected();
  }

  public void updateCountersList(Vector counters) {
    this.server_list[COUNTER] = counters;
    Vector aux;
    Server server;
    aux = new Vector(this.server_list[COUNTER].size());
    for (int i = 0; i < this.server_list[COUNTER].size(); i++) {
      server = (Server)this.server_list[COUNTER].get(i);
      aux.add(server.GetDescription());
    }
    this.server_selection[COUNTER].setListData(aux);
    this.setSelected();
  }

  void setSelected(){
    if (this.selection > -1) {
      int index = this.servers.getSelectedIndex();
      this.server_selection[index].setSelectedIndex(this.selection);
      this.server_selection[index].ensureIndexIsVisible(this.selection);
    }
    this.cancel_actionPerformed(null);
  }

  public byte getTypeOfServer(){
    return (byte) this.servers.getSelectedIndex();
  }

  public Server getServer(){
    int index = this.servers.getSelectedIndex();
    int server_index = this.server_selection[index].getSelectedIndex();
    Server server = (Server) this.server_list[index].get(server_index);
    server.SetDescription(this.description.getText());
    server.SetURL(this.URL.getText());
    server.SetEnable(this.enable.isSelected());
    return server;
  }

  void change_server(){
    int index = this.servers.getSelectedIndex();
    if (index==-1)
      return;
    if (this.state == ServersAdministration.NONE)
      this.selection = this.server_selection[index].getSelectedIndex();
    if (this.selection==-1){
      this.description.setText("");
      this.URL.setText("");
      this.enable.setSelected(false);
      return;
    }

    Server server = (Server) this.server_list[index].get(this.selection);
    this.description.setText(server.GetDescription());
    this.URL.setText(server.GetURL());
    this.enable.setSelected(server.IsEnable());
  }


  void distributors_selection_valueChanged(ListSelectionEvent e) {
    this.change_server();
  }

  void administrators_selection_valueChanged(ListSelectionEvent e) {
    this.change_server();
  }

  void anonymizers_selection_valueChanged(ListSelectionEvent e) {
    this.change_server();
  }

  void counters_selection_valueChanged(ListSelectionEvent e) {
    this.change_server();
  }



  void cancel_actionPerformed(ActionEvent e) {
    this.ok.setEnabled(false);
    this.load_key.setEnabled(false);
    this.cancel.setEnabled(false);
    this.description.setEditable(false);
    this.URL.setEditable(false);
    this.enable.setEnabled(false);
    this.back.setEnabled(true);
    this.edit.setEnabled(true);
    this.state = ServersAdministration.NONE;

    this.change_server();
  }

  void edit_actionPerformed(ActionEvent e) {
    this.back.setEnabled(false);
    this.edit.setEnabled(false);

    this.description.setEditable(true);
    this.URL.setEditable(true);
    this.enable.setEnabled(true);
    this.ok.setEnabled(true);
    this.load_key.setEnabled(true);
    this.cancel.setEnabled(true);
    this.state = ServersAdministration.UPDATE;

  }

  public void setActionListener(Commissioner commi) {
   back.addActionListener(new ServersAdministration_back_actionAdapter(commi));
   ok.addActionListener(new ServersAdministration_ok_actionAdapter(commi));
   load_key.addActionListener(new ServersAdministration_load_key_actionAdapter(commi));
 }

  void Distributors_focusGained(FocusEvent e) {
    this.change_server();
  }

  void Administrators_focusGained(FocusEvent e) {
    this.change_server();
  }

  void Anonymizers_focusGained(FocusEvent e) {
    this.change_server();
  }

  void Counters_focusGained(FocusEvent e) {
    this.change_server();
  }













}

class ServersAdministration_distributors_selection_listSelectionAdapter implements javax.swing.event.ListSelectionListener {
  ServersAdministration adaptee;

  ServersAdministration_distributors_selection_listSelectionAdapter(ServersAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void valueChanged(ListSelectionEvent e) {
    adaptee.distributors_selection_valueChanged(e);
  }
}

class ServersAdministration_administrators_selection_listSelectionAdapter implements javax.swing.event.ListSelectionListener {
  ServersAdministration adaptee;

  ServersAdministration_administrators_selection_listSelectionAdapter(ServersAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void valueChanged(ListSelectionEvent e) {
    adaptee.administrators_selection_valueChanged(e);
  }
}

class ServersAdministration_anonymizers_selection_listSelectionAdapter implements javax.swing.event.ListSelectionListener {
  ServersAdministration adaptee;

  ServersAdministration_anonymizers_selection_listSelectionAdapter(ServersAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void valueChanged(ListSelectionEvent e) {
    adaptee.anonymizers_selection_valueChanged(e);
  }
}

class ServersAdministration_counters_selection_listSelectionAdapter implements javax.swing.event.ListSelectionListener {
  ServersAdministration adaptee;

  ServersAdministration_counters_selection_listSelectionAdapter(ServersAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void valueChanged(ListSelectionEvent e) {
    adaptee.counters_selection_valueChanged(e);
  }
}

class ServersAdministration_ok_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  ServersAdministration_ok_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.SAok_actionPerformed(e);
  }
}

class ServersAdministration_cancel_actionAdapter implements java.awt.event.ActionListener {
  ServersAdministration adaptee;

  ServersAdministration_cancel_actionAdapter(ServersAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cancel_actionPerformed(e);
  }
}

class ServersAdministration_edit_actionAdapter implements java.awt.event.ActionListener {
  ServersAdministration adaptee;

  ServersAdministration_edit_actionAdapter(ServersAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.edit_actionPerformed(e);
  }
}

class ServersAdministration_back_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  ServersAdministration_back_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.SAback_actionPerformed(e);
  }
}

class ServersAdministration_Distributors_focusAdapter extends java.awt.event.FocusAdapter {
  ServersAdministration adaptee;

  ServersAdministration_Distributors_focusAdapter(ServersAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void focusGained(FocusEvent e) {
    adaptee.Distributors_focusGained(e);
  }
}

class ServersAdministration_Administrators_focusAdapter extends java.awt.event.FocusAdapter {
  ServersAdministration adaptee;

  ServersAdministration_Administrators_focusAdapter(ServersAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void focusGained(FocusEvent e) {
    adaptee.Administrators_focusGained(e);
  }
}

class ServersAdministration_Anonymizers_focusAdapter extends java.awt.event.FocusAdapter {
  ServersAdministration adaptee;

  ServersAdministration_Anonymizers_focusAdapter(ServersAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void focusGained(FocusEvent e) {
    adaptee.Anonymizers_focusGained(e);
  }
}

class ServersAdministration_Counters_focusAdapter extends java.awt.event.FocusAdapter {
  ServersAdministration adaptee;

  ServersAdministration_Counters_focusAdapter(ServersAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void focusGained(FocusEvent e) {
    adaptee.Counters_focusGained(e);
  }
}

class ServersAdministration_load_key_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  ServersAdministration_load_key_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.SAload_key_actionPerformed(e);
  }
}








