package inescID.revs.commissioner;

import java.awt.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
import java.awt.event.*;


import java.sql.*;
import java.util.Vector;
import javax.swing.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

import inescID.revs.util.IdDescription;

public class VoterAdministration extends JPanel {

  public static final byte NONE = 0;
  public static final byte UPDATE = 1;
  public static final byte NEW = 2;

  private byte state;
  private Vector voters;
  private IdDescription voter;

  Box box1;
  JPanel pTitle = new JPanel();
  JLabel title = new JLabel();
  JPanel pMain = new JPanel();
  Box mainBox;
  JScrollPane listScrollPane = new JScrollPane();
  JList selectionList = new JList();
  JPanel pButtons = new JPanel();
  JButton update = new JButton();
  BoxLayout2 pButtonsLayout = new BoxLayout2();
  JButton New = new JButton();
  JButton delete = new JButton();
  Component space2;
  JButton back = new JButton();

  Box box5;
  JPanel jPanel1 = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JLabel Lname = new JLabel();
  JTextField name = new JTextField();
  JLabel Lnumber = new JLabel();
  JTextField number = new JTextField();
  JButton ok = new JButton();
  JButton cancel = new JButton();
  JButton groups = new JButton();
  Component space3;
  Component space4;
  JButton change_password = new JButton();


  public VoterAdministration(Commissioner commi) {
    this.start();
    this.setActionListener(commi);
  }



  public VoterAdministration() {
    this.start();

  }

  private void start(){
    this.state = VoterAdministration.NONE;
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    box1 = Box.createVerticalBox();
    mainBox = Box.createHorizontalBox();
    space2 = Box.createVerticalStrut(26);
    box5 = Box.createVerticalBox();
    space3 = Box.createVerticalStrut(12);
    space4 = Box.createVerticalStrut(24);
    this.setBorder(BorderFactory.createEtchedBorder());
    this.setMinimumSize(new Dimension(0, 0));

    this.setOpaque(true);
    this.setPreferredSize(new Dimension(0, 0));
    title.setFont(new java.awt.Font("Dialog", 0, 18));
    title.setMinimumSize(new Dimension(98, 15));
    title.setText("Voter Administration");
    pButtons.setLayout(pButtonsLayout);
    update.setEnabled(false);
    update.setAlignmentX((float) 0.0);
    update.setMaximumSize(new Dimension(123, 23));
    update.setOpaque(true);
    update.setHorizontalAlignment(SwingConstants.CENTER);
    update.setHorizontalTextPosition(SwingConstants.CENTER);
    update.setText("Rename");
    update.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
    update.setVerticalTextPosition(javax.swing.SwingConstants.CENTER);
    update.addActionListener(new VoterAdministration_update_actionAdapter(this));
    pButtonsLayout.setAxis(BoxLayout.Y_AXIS);
    New.setEnabled(false);
    New.setMaximumSize(new Dimension(123, 23));
    New.setMnemonic('0');
    New.setSelected(false);
    New.setText("New");
    New.addActionListener(new VoterAdministration_New_actionAdapter(this));
    delete.setEnabled(false);
    delete.setMaximumSize(new Dimension(123, 23));
    delete.setText("Delete");

    back.setAlignmentX((float) -1.0);
    back.setMaximumSize(new Dimension(123, 23));
    back.setHorizontalAlignment(SwingConstants.CENTER);
    back.setMargin(new Insets(2, 14, 2, 14));
    back.setText("Back");

    listScrollPane.setPreferredSize(new Dimension(150, 400));
    jPanel1.setLayout(gridBagLayout1);
    Lname.setText("Name");
    name.setEditable(false);
    name.setSelectionStart(11);
    name.setText("");
    Lnumber.setHorizontalTextPosition(SwingConstants.CENTER);
    Lnumber.setText("Number");
    number.setEditable(false);
    number.setText("");
    ok.setEnabled(false);
    ok.setMaximumSize(new Dimension(65, 23));
    ok.setMinimumSize(new Dimension(65, 23));
    ok.setPreferredSize(new Dimension(65, 23));
    ok.setMnemonic('0');
    ok.setText("OK");
    cancel.setEnabled(false);
    cancel.setText("Cancel");
    cancel.addActionListener(new VoterAdministration_cancel_actionAdapter(this));
    selectionList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    selectionList.addListSelectionListener(new VoterAdministration_selectionList_listSelectionAdapter(this));
    groups.setMaximumSize(new Dimension(123, 23));
    groups.setText("Voters Groups");

    change_password.setEnabled(false);
    change_password.setText("Change Password");
    this.add(box1, null);
    box1.add(pTitle, null);
    pTitle.add(title, null);
    box1.add(pMain, null);
    pMain.add(mainBox, null);
    mainBox.add(listScrollPane, null);
    mainBox.add(box5, null);
    box5.add(pButtons, null);
    listScrollPane.getViewport().add(selectionList, null);
    jPanel1.add(name,                                  new GridBagConstraints(1, 1, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 0, 0, 0), 210, 0));
    jPanel1.add(number,                               new GridBagConstraints(1, 0, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 50, 0));
    jPanel1.add(Lnumber,                 new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 10, 0, 10), 0, 0));
    jPanel1.add(Lname,               new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 10, 0, 10), 0, 0));
    jPanel1.add(ok,            new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(10, 50, 0, 10), 0, 0));
    jPanel1.add(cancel,           new GridBagConstraints(2, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 0, 0, 0), 0, 0));
    pButtons.add(jPanel1, null);
    pButtons.add(update, null);
    pButtons.add(change_password, null);
    pButtons.add(New, null);
    pButtons.add(delete, null);
    pButtons.add(space3, null);
    pButtons.add(groups, null);
    pButtons.add(space2, null);
    pButtons.add(back, null);
    box5.add(space4, null);
  }

  public void releaseMemory(){
    this.voters = null;
    this.voter=null;
    this.selectionList.removeAll();
}



  public void updateList(Vector list){
    int voter_number = -1;
    if (this.state != VoterAdministration.NONE)
      voter_number = voter.GetId();

    this.reset();
    this.voters = list;
    Vector aux = new Vector(this.voters.size());

    for (int i=0; i<this.voters.size(); i++)
      aux.add(new Integer(((IdDescription) this.voters.get(i)).GetId()));

    this.selectionList.setListData(aux);

    if(voter_number != -1)
      this.selectionList.setSelectedValue(new Integer(voter_number), true);

    this.changeVoter();
  }

  public IdDescription getVoter()
  {

    this.voter = new IdDescription();
    this.voter.SetId(Integer.parseInt(this.number.getText()));
    this.voter.SetDescription(this.name.getText());
    return this.voter;
  }

  public byte getState()
  {
    return this.state;
  }


  public void setActionListener(Commissioner commi) {
    back.addActionListener(new VoterAdministration_back_actionAdapter(commi));
    delete.addActionListener(new VoterAdministration_delete_actionAdapter(commi));
    ok.addActionListener(new VoterAdministration_ok_actionAdapter(commi));
    groups.addActionListener(new VoterAdministration_groups_actionAdapter(commi));
    change_password.addActionListener(new VoterAdministration_change_password_actionAdapter(commi));
  }

  void cancel_actionPerformed(ActionEvent e) {
    this.reset();
    this.changeVoter();

  }


  public void reset(){

    this.number.setEditable(false);
    this.name.setEditable(false);
    this.ok.setEnabled(false);
    this.cancel.setEnabled(false);

    this.state=VoterAdministration.NONE;
    this.number.setText("");
    this.name.setText("");

    this.selectionList.setEnabled(true);
    this.back.setEnabled(true);
    this.New.setEnabled(true);
    this.groups.setEnabled(true);
  }

  void enableActions(){
    this.update.setEnabled(true);
    this.change_password.setEnabled(true);
    this.delete.setEnabled(true);
  }

  void disableActions(){
    this.update.setEnabled(false);
    this.change_password.setEnabled(false);
    this.delete.setEnabled(false);
  }




  void update_actionPerformed(ActionEvent e) {
    this.selectionList.setEnabled(false);
    this.back.setEnabled(false);
    this.groups.setEnabled(false);
    this.New.setEnabled(false);

    this.disableActions();

    this.state = VoterAdministration.UPDATE;

    this.name.setEditable(true);
    this.ok.setEnabled(true);
    this.cancel.setEnabled(true);
  }

  void New_actionPerformed(ActionEvent e) {
    this.selectionList.setEnabled(false);
    this.disableActions();
    this.New.setEnabled(false);

    this.state = VoterAdministration.NEW;

    if (voters.size()<1)
      this.number.setText("1");
    else
    {
        this.voter = (IdDescription) this.voters.lastElement();
        this.number.setText(Integer.toString(voter.GetId()+1));
    }

    this.name.setText("");


    this.number.setEditable(true);
    this.name.setEditable(true);
    this.ok.setEnabled(true);
    this.cancel.setEnabled(true);
  }


  void selectionList_valueChanged(ListSelectionEvent e) {
    this.changeVoter();
  }

  private void changeVoter(){
    if(this.selectionList.getSelectedIndex()>=0){
      this.voter = (IdDescription)this.voters.get(this.selectionList.getSelectedIndex());
      this.number.setText(Integer.toString(this.voter.GetId()));
      this.name.setText(this.voter.GetDescription());
      this.enableActions();
    }
    else
      this.disableActions();
  }

}


class VoterAdministration_update_actionAdapter implements java.awt.event.ActionListener {
  VoterAdministration adaptee;

  VoterAdministration_update_actionAdapter(VoterAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.update_actionPerformed(e);
  }
}

class VoterAdministration_New_actionAdapter implements java.awt.event.ActionListener {
  VoterAdministration adaptee;

  VoterAdministration_New_actionAdapter(VoterAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.New_actionPerformed(e);
  }
}

class VoterAdministration_delete_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  VoterAdministration_delete_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.VMdelete_actionPerformed(e);
  }
}

class VoterAdministration_back_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  VoterAdministration_back_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.VMback_actionPerformed(e);
  }
}

class VoterAdministration_ok_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  VoterAdministration_ok_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.VMok_actionPerformed(e);
  }
}

class VoterAdministration_cancel_actionAdapter implements java.awt.event.ActionListener {
  VoterAdministration adaptee;

  VoterAdministration_cancel_actionAdapter(VoterAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cancel_actionPerformed(e);
  }
}

class VoterAdministration_selectionList_listSelectionAdapter implements javax.swing.event.ListSelectionListener {
  VoterAdministration adaptee;

  VoterAdministration_selectionList_listSelectionAdapter(VoterAdministration adaptee) {
    this.adaptee = adaptee;
  }
  public void valueChanged(ListSelectionEvent e) {
    adaptee.selectionList_valueChanged(e);
  }
}

class VoterAdministration_groups_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  VoterAdministration_groups_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.VMgroups_actionPerformed(e);
  }
}

class VoterAdministration_change_password_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  VoterAdministration_change_password_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.VMchange_password_actionPerformed(e);
  }
}


