package inescID.revs.commissioner;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public class VoterPassword extends JDialog {

  JPanel panel1 = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JRadioButton password_pin = new JRadioButton();
  JRadioButton just_password = new JRadioButton();
  JLabel title = new JLabel();
  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JLabel lpassword = new JLabel();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  JTextField password = new JTextField();
  GridBagLayout gridBagLayout3 = new GridBagLayout();
  JLabel lpin = new JLabel();
  JTextField pin = new JTextField();
  JButton create_passwords = new JButton();
  JPanel jPanel4 = new JPanel();
  JButton cancel = new JButton();
  Box box1;
  Component component1;
  Component component2;
  JPanel jPanel6 = new JPanel();
  ButtonGroup groupPasswords = new ButtonGroup();
  JPasswordField hidden_password = new JPasswordField();
  JPasswordField hidden_pin = new JPasswordField();
  JButton ok = new JButton();
  JPasswordField hidden_password_confirmation = new JPasswordField();
  JPasswordField hidden_pin_confirmation = new JPasswordField();
  JLabel labelConfirmation = new JLabel();

  public VoterPassword(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public VoterPassword(Commissioner commi, Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }

    this.setActionListener(commi);
    this.password.setVisible(false);
    this.pin.setVisible(false);
    this.password_pin.setSelected(true);
  }

  public VoterPassword() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {

    //this.password_pin.g

    box1 = Box.createVerticalBox();
    component1 = Box.createVerticalStrut(5);
    component2 = Box.createVerticalStrut(7);
    panel1.setLayout(gridBagLayout1);
    password_pin.setEnabled(true);
    password_pin.setText("Password and PIN");
    password_pin.addActionListener(new VoterPassword_password_pin_actionAdapter(this));
    just_password.setText("Just Password");
    just_password.addActionListener(new VoterPassword_just_password_actionAdapter(this));
    title.setFont(new java.awt.Font("Dialog", 0, 18));
    title.setToolTipText("");
    title.setText("Enter voter\'s password(s)");
    this.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    this.setTitle("Password");
    jPanel2.setLayout(gridBagLayout2);
    panel1.setBorder(BorderFactory.createEtchedBorder());
    lpassword.setText("Password");

    password.setMinimumSize(new Dimension(11, 22));
    password.setPreferredSize(new Dimension(107, 22));
    password.setEditable(false);
    password.setColumns(12);
    jPanel3.setLayout(gridBagLayout3);
    lpin.setText("PIN");
    pin.setMinimumSize(new Dimension(11, 22));
    pin.setPreferredSize(new Dimension(59, 22));
    pin.setEditable(false);
    pin.setText("");
    pin.setColumns(6);
    create_passwords.setText("Create Passwords");
    cancel.setMaximumSize(new Dimension(65, 23));
    cancel.setMinimumSize(new Dimension(65, 23));
    cancel.setPreferredSize(new Dimension(65, 23));
    cancel.setHorizontalAlignment(SwingConstants.CENTER);
    cancel.setHorizontalTextPosition(SwingConstants.CENTER);
    cancel.setSelected(false);
    cancel.setText("Cancel");
    cancel.addActionListener(new VoterPassword_cancel_actionAdapter(this));

    hidden_password.setEnabled(true);
    hidden_password.setAlignmentX((float) 0.5);
    hidden_password.setEditable(true);
    hidden_password.setColumns(12);
    hidden_pin.setEnabled(true);
    hidden_pin.setEditable(true);
    hidden_pin.setText("");
    hidden_pin.setColumns(6);
    ok.setText("OK");
    ok.setHorizontalTextPosition(SwingConstants.CENTER);
    ok.setHorizontalAlignment(SwingConstants.CENTER);
    ok.setPreferredSize(new Dimension(65, 23));
    ok.setMinimumSize(new Dimension(65, 23));
    ok.setMaximumSize(new Dimension(65, 23));
    jPanel6.setAlignmentX((float) 0.0);
    jPanel6.setMinimumSize(new Dimension(280, 33));
    jPanel6.setPreferredSize(new Dimension(280, 33));
    hidden_password_confirmation.setColumns(12);
    hidden_password_confirmation.setEditable(true);
    hidden_password_confirmation.setAlignmentX((float) 0.5);
    hidden_password_confirmation.setEnabled(true);
    hidden_pin_confirmation.setColumns(6);
    hidden_pin_confirmation.setText("");
    hidden_pin_confirmation.setEditable(true);
    hidden_pin_confirmation.setEnabled(true);
    labelConfirmation.setText("Confirmation");
    jPanel6.add(ok, null);
    jPanel6.add(cancel, null);
    panel1.add(password_pin, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel1.add(just_password, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    this.getContentPane().add(jPanel1, BorderLayout.NORTH);
    jPanel1.add(title, null);
    this.getContentPane().add(jPanel2,  BorderLayout.CENTER);
    jPanel2.add(panel1,       new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel2.add(jPanel3,      new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.VERTICAL, new Insets(0, 0, 1, 0), 0, 0));
    jPanel3.add(lpassword,                new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 10, 5, 10), 0, 0));
    jPanel3.add(lpin,             new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 0, 5, 0), 0, 0));
    jPanel3.add(hidden_password,            new GridBagConstraints(1, 2, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
    jPanel3.add(hidden_pin,          new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
    jPanel3.add(pin,         new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
    jPanel3.add(password,         new GridBagConstraints(1, 2, 2, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
    jPanel3.add(create_passwords,                       new GridBagConstraints(1, 4, 3, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 20, 0, 10), 0, 0));
    jPanel3.add(hidden_password_confirmation,           new GridBagConstraints(3, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 15, 0, 0), 0, 0));
    jPanel3.add(hidden_pin_confirmation,      new GridBagConstraints(3, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 15, 0, 0), 0, 0));
    this.getContentPane().add(jPanel4,  BorderLayout.SOUTH);
    jPanel4.add(box1, null);
    box1.add(component2, null);
    box1.add(jPanel6, null);
    box1.add(component1, null);
    groupPasswords.add(password_pin);
    groupPasswords.add(just_password);
    jPanel3.add(labelConfirmation,  new GridBagConstraints(3, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 5, 0), 0, 0));
  }




  public char[][] getPasswordPIN(){
    char[][] passwords = new char[2][];
    passwords[0] = this.hidden_password.getPassword();
    passwords[1] = this.hidden_pin.getPassword();
    return passwords;
  }

  public char[][] getConfirmedPasswordPIN(){

    if (!(java.util.Arrays.equals(this.hidden_password.getPassword(),
                                  this.hidden_password_confirmation.getPassword()))
        || !(java.util.Arrays.equals(this.hidden_pin.getPassword(),
                                     this.hidden_pin_confirmation.getPassword())))
      return null;

    char[][] passwords = new char[2][];
    passwords[0] = this.hidden_password.getPassword();
    passwords[1] = (this.password_pin.isSelected() ? this.hidden_pin.getPassword() : null);
    return passwords;
  }


 void clearPasswords(){
   this.hidden_pin.setVisible(true);
   this.hidden_password.setVisible(true);
   this.pin.setVisible(false);
   this.password.setVisible(false);

   this.hidden_pin.setText("");
   this.hidden_password.setText("");
   this.hidden_pin_confirmation.setText("");
   this.hidden_password_confirmation.setText("");
   this.pin.setText("");
   this.password.setText("");


 }

  void password_pin_actionPerformed(ActionEvent e) {
    this.hidden_pin.setEditable(true);
    this.hidden_pin_confirmation.setEditable(true);
    this.hidden_pin.setVisible(true);

    this.hidden_password.setVisible(true);
    this.hidden_password.setEditable(true);
    this.hidden_password_confirmation.setEditable(true);


    this.clearPasswords();
  }

  void just_password_actionPerformed(ActionEvent e) {
    this.hidden_pin.setEditable(false);
    this.hidden_pin_confirmation.setEditable(false);
    this.hidden_password.setVisible(true);
    this.hidden_password_confirmation.setEditable(true);

    this.clearPasswords();
  }


  public void setPasswordPin(char[][] passwords){
    this.hidden_password.setVisible(false);
    this.hidden_password_confirmation.setEditable(false);

    this.password.setVisible(true);
    this.password.setText(new String(passwords[0]));
    this.hidden_password.setText(new String(passwords[0]));
    this.hidden_password_confirmation.setText(new String(passwords[0]));

    if (this.password_pin.isSelected()){
      this.hidden_pin.setVisible(false);
      this.hidden_pin_confirmation.setEditable(false);

      this.pin.setVisible(true);
      this.pin.setText(new String(passwords[1]));
      this.hidden_pin.setText(new String(passwords[1]));
      this.hidden_pin_confirmation.setText(new String(passwords[1]));
   }

  }

  void cancel_actionPerformed(ActionEvent e) {
    this.dispose();
  }

  public void setActionListener(Commissioner commi) {
      ok.addActionListener(new VoterPassword_ok_actionAdapter(commi));
      create_passwords.addActionListener(new VoterPassword_create_passwords_actionAdapter(commi));
    }


}

class VoterPassword_password_pin_actionAdapter implements java.awt.event.ActionListener {
  VoterPassword adaptee;

  VoterPassword_password_pin_actionAdapter(VoterPassword adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.password_pin_actionPerformed(e);
  }
}

class VoterPassword_just_password_actionAdapter implements java.awt.event.ActionListener {
  VoterPassword adaptee;

  VoterPassword_just_password_actionAdapter(VoterPassword adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.just_password_actionPerformed(e);
  }
}

class VoterPassword_create_passwords_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  VoterPassword_create_passwords_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.VPcreate_passwords_actionPerformed(e);
  }
}

class VoterPassword_ok_actionAdapter implements java.awt.event.ActionListener {
  Commissioner adaptee;

  VoterPassword_ok_actionAdapter(Commissioner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.VPok_actionPerformed(e);
  }
}

class VoterPassword_cancel_actionAdapter implements java.awt.event.ActionListener {
  VoterPassword adaptee;

  VoterPassword_cancel_actionAdapter(VoterPassword adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cancel_actionPerformed(e);
  }
}
