package inescID.revs.displayBallot;

import java.awt.*;
import javax.swing.*;
import java.util.Vector;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

import inescID.revs.xml.*;
import com.borland.jbcl.layout.*;
import javax.swing.border.*;

public class PanelGroup extends JPanel {
  BorderLayout borderLayout1 = new BorderLayout();
  JLabel description = new JLabel();
  JPanel questions_panel = new JPanel();
  VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();

  BallotGroup group;
  Vector panel_questions; //PanelQuestion or PanelGroup

  TitledBorder titledBorder2;
  TitledBorder titledBorder3;

  public PanelGroup() {
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {


    titledBorder2 = new TitledBorder("");
    titledBorder3 = new TitledBorder("");
    this.setLayout(borderLayout1);
    questions_panel.setLayout(verticalFlowLayout1);


    description.setBackground(Color.pink);
    description.setFont(new java.awt.Font("Garamond", 1, 22));
    description.setBorder(titledBorder2);
    description.setOpaque(true);
    description.setHorizontalAlignment(SwingConstants.LEFT);
    description.setHorizontalTextPosition(SwingConstants.LEFT);
    questions_panel.setBackground(Color.pink);
    questions_panel.setBorder(titledBorder3);
    verticalFlowLayout1.setVerticalFill(true);
    this.add(description, BorderLayout.NORTH);
    this.add(questions_panel, BorderLayout.CENTER);
  }

  public void setGroup(BallotGroup group){
    this.group = group;
    description.setText(this.group.getDescription());
    Vector questions = this.group.getQuestions();
    this.panel_questions = new Vector(questions.size());
    BallotQuestion question;
    for(int i=0; i<questions.size(); i++){
      try {
        question = (BallotQuestion) questions.get(i);
        PanelQuestion panel_question = new PanelQuestion();
        panel_question.setQuestion(question);
        this.panel_questions.add(panel_question);
        this.questions_panel.add(panel_question);
      }
      catch (Exception ex) {
        BallotGroup subgroup;
        subgroup = (BallotGroup) questions.get(i);
        PanelGroup panel_subgroup = new PanelGroup();
        panel_subgroup.setGroup(subgroup);
        panel_subgroup.setSubGroup();
        this.panel_questions.add(panel_subgroup);
        this.questions_panel.add(panel_subgroup);
        continue;
      }
   }
  }

  BallotGroup getAnswers(){
    Vector answers = new Vector();
    for(int i=0; i<this.panel_questions.size(); i++){
      try {
        answers.add(((PanelQuestion)this.panel_questions.get(i)).getAnswers());
      }
      catch (Exception ex) {
        answers.add(((PanelGroup)this.panel_questions.get(i)).getAnswers());
      }
    }
    this.group.setQuestions(answers);
    return this.group;
  }

  public void setSubGroup(){
    description.setFont(new java.awt.Font("Garamond", 1, 16));
 //    this.description.setBackground(SystemColor.control);
  }

  void setPortuguese(){
    for(int i=0; i<this.panel_questions.size(); i++){
      try {
        ((PanelQuestion)this.panel_questions.get(i)).setPortuguese();
      }
      catch (Exception ex) {
        ((PanelGroup)this.panel_questions.get(i)).setPortuguese();
      }
    }


  }

}
