package inescID.revs.servers;

import java.net.PasswordAuthentication;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public interface CommonServerInterface {

  public abstract void createDatabase();
  public abstract void deleteDatabase();
  public abstract void redoDatabase();
  public abstract void updateDatabase(String file);
  public abstract void init(String database_address, PasswordAuthentication db_authentication);
  public abstract boolean start();
  public abstract void stop();

}
