package inescID.revs.util.protocol;

/**
 * <p>Title: Resposta</p>
 * <p>Description: Classe base para retorno das funes</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */
public class Reply implements java.io.Serializable {

  byte error_code;
  Object obj;

  public Reply(byte error_code, Object obj){
    this.error_code = error_code;
    this.obj = obj;
  }

  public Object getObject() {
    return this.obj;
  }

  public byte getErrorCode(){
    return this.error_code;
  }

}
