package inescID.revs.voter;

import java.awt.*;
import javax.swing.*;
import java.util.Vector;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company Inesc-ID</p>
 * @author Rui Joaquim
 * @version 1.0
 * @license REVS is freely available under the GNU GENERAL PUBLIC LICENCE
 */

public class PanelElectionList extends JPanel {
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JLabel lselect_election = new JLabel();
  JScrollPane jScrollPane1 = new JScrollPane();
  JList elections = new JList();

  public PanelElectionList() {
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    lselect_election.setFont(new java.awt.Font("Garamond", 1, 16));
    lselect_election.setText("Select Election");
    this.setLayout(gridBagLayout1);
    elections.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jScrollPane1.setMinimumSize(new Dimension(260, 300));
    jScrollPane1.setPreferredSize(new Dimension(260, 300));
    this.add(lselect_election,    new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(20, 0, 40, 0), 0, 0));
    this.add(jScrollPane1,  new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jScrollPane1.getViewport().add(elections, null);
  }

  public void setElections(Vector elections){
    this.elections.setListData(elections);
  }

  public int getSelectedElection(){
    return this.elections.getSelectedIndex();
  }

}
